#!/usr/bin/env python

import sys
import re
import os
from pymod.inifile import *

def Convert(infile, outfile, sub):

    if type (infile) == type (''):
        infile = open (infile, 'r')
    if type (outfile) == type (''):
        outfile = open (outfile, 'w')

    while 1:
        line = infile.readline()
        if line == '': break        # end of file

        for keys in sub['one'].keys():
            line = re.sub (keys, sub['one'][keys], line)

        for keys in sub['two'].keys():
            line = re.sub (keys, sub['two'][keys], line)

        for keys in sub['always'].keys():
            line = re.sub (keys, sub['always'][keys], line)

        outfile.write("%s" % line)

    outfile.close ()

def main(argv):

    if (len(argv) != 2 or
        argv[0] == '-h' or argv[0] == '-help' or argv[0] == '--help'):
        print 'script <infile> <outfile> <dictionary>'
        sys.exit(0)

    print argv[0]
    print argv[1]
    
    sub = Substitute()
    sub.read_file (argv[1])
    print sub

    infile = open (argv[0], 'r')
    outfile = open ('conv.tmp', 'w')

    Convert (infile, outfile, sub)
#    os.rename (argv[0], 'junk')
#    os.rename ('conv.tmp', argv[0])
    

if __name__ == '__main__':
    args = sys.argv[1:]
    main(args)
