
setenv DGP_OSTYPE 		x86_win32
setenv MAKE_MODE		unix
setenv DGP_IPC_DIR		"x:/IPCORE"
setenv DGP_WIN32_INCLUDE	"C:/Program Files/Microsoft Visual Studio/VC98/include"
setenv BMKHOME                  d:/scansoft/bmk
setenv INCLUDE                  "C:/Program Files/Microsoft Visual Studio/VC98/include;C:/Program Files/Microsoft Visual Studio/VC98/MFC/Include"
setenv LIB                      "C:/Program Files/Microsoft Visual Studio/VC98/lib;C:/Program Files/Microsoft Visual Studio/VC98/MFC/Lib"

set path = ( \
D:/bin \
c:/apps/cygwin-b20/H-i586-cygwin32/bin \
C:/WINNT/system32 \
C:/WINNT \
"C:/Program Files/Microsoft Visual Studio/Common/Tools/WinNT" \
"C:/Program Files/Microsoft Visual Studio/Common/MSDev98/Bin" \
"C:/Program Files/Microsoft Visual Studio/Common/Tools" \
"C:/Program Files/Microsoft Visual Studio/VC98/bin" \
"c:/Program Files/Microsoft Visual Studio/VC98/Bin" \
"c:/apps/py152" \
)

umask 002
unalias cd

######   find DGP_DIR
cd x:/digipaper
set TODAY = `date +%Y%m%d`
set NEWDIR = build${TODAY}
setenv DGP_DIR x:/digipaper/${NEWDIR}/digipaper

######   compile source

if (-e ${DGP_DIR} && \
    -e ${DGP_DIR}/include) then
  cd ${DGP_DIR}/src
  make >& d:/cron/make.log
else
  echo "$DGP_DIR not found" >! d:/cron/make.log
  exit
endif

######   copy executables


cd ${DGP_DIR}/bin/x86_win32
if (-e santa_uncomp_all.exe) then
  cp santa_uncomp_all.exe d:/scansoft/testbed/bin/santa_uncomp_all.exe
else
  echo "santa_uncomp_all not found\n" >> d:/cron/make.log
  exit
endif

if (-e tcomp-lossless.exe) then
  cp tcomp-lossless.exe d:/scansoft/testbed/bin/tcomp_lossless.exe
else
  echo "tcomp_lossless not found\n" >> d:/cron/make.log
  exit
endif

if (-e tcomp-lossy.exe) then
  cp tcomp-lossy.exe d:/scansoft/testbed/bin/tcomp_lossy.exe
else
  echo "tcomp_lossy not found\n" >> d:/cron/make.log
  exit
endif


###### create directories for OCR test


cd d:/scansoft/testbed
if (-e tcomp_lossless) rm -rf tcomp_lossless
if (-e tcomp_lossy)    rm -rf tcomp_lossy

mkdir tcomp_lossless
mkdir tcomp_lossless/tif
mkdir tcomp_lossy
mkdir tcomp_lossy/tif


##### run OCR test

(python bin/create_tif.py > outfile) >& errlog
if (-e outfile) cp outfile summary.xls $DGP_DIR

# exit
