
#include "PDFReader.h"
#include <iostream>

int main (int argc, char** argv)
{

	if (argc != 3)
    {
        std::cout << "Enter input and output PDF filename\n";
        exit (0);
    }

	PDFReader finder (argv[1]);

    finder.getObjects ();
    if (finder.findAndEncodeBinaryImages ())
        finder.generateOutputPDF(argv[2]);
    else
        std::cout << "No output created, because no images for compression found in this PDF file\n";

    return 1;
}