#ifndef ___MASK_TABLE_H___
#define ___MASK_TABLE_H___

#ifdef __cplusplus
extern "C"
{
#endif
    
    
    inline
        void mask_pixel_assign_1_0(Asd::UInt8 * outptr, Asd::UInt8 *fgptr){
    }
    inline 
        void mask_pixel_assign_1_1(Asd::UInt8 *outptr, Asd::UInt8 *fgptr){ 
        
        outptr += 3* RGB_PIXELSIZE;
        *fgptr += 3* RGB_PIXELSIZE;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr = *fgptr++;
    }
    
    inline 
        void mask_pixel_assign_1_2(Asd::UInt8 * outptr, Asd::UInt8 *fgptr){
        
        outptr += 2 * RGB_PIXELSIZE;
        *fgptr += 2 * RGB_PIXELSIZE;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr = *fgptr++;
        
    }
    inline 
        void mask_pixel_assign_1_3(Asd::UInt8 * outptr, Asd::UInt8 *fgptr){
        
        outptr += 2 * RGB_PIXELSIZE;
        *fgptr += 2 * RGB_PIXELSIZE;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr = *fgptr++;
        
    }
    inline 
        void mask_pixel_assign_1_4(Asd::UInt8 * outptr, Asd::UInt8 *fgptr){

        outptr += RGB_PIXELSIZE;
        *fgptr +=  RGB_PIXELSIZE;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        
    }
    inline 
        void mask_pixel_assign_1_5(Asd::UInt8 * outptr, Asd::UInt8 *fgptr){
        
        outptr += RGB_PIXELSIZE;
        *fgptr +=  RGB_PIXELSIZE;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        outptr +=  RGB_PIXELSIZE;
        *fgptr +=  RGB_PIXELSIZE;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr = *fgptr++;
        
    }
    inline 
        void mask_pixel_assign_1_6(Asd::UInt8 * outptr, Asd::UInt8 *fgptr){
        
        outptr += RGB_PIXELSIZE;
        *fgptr += RGB_PIXELSIZE;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
    }
    inline 
        void mask_pixel_assign_1_7(Asd::UInt8 * outptr, Asd::UInt8 *fgptr){
        outptr += RGB_PIXELSIZE;
        *fgptr += RGB_PIXELSIZE;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
    }
    inline 
        void mask_pixel_assign_1_8(Asd::UInt8 * outptr, Asd::UInt8 *fgptr){
        
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
    }
    inline 
        void mask_pixel_assign_1_9(Asd::UInt8 * outptr, Asd::UInt8 *fgptr){
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        outptr += 2 * RGB_PIXELSIZE;
        *fgptr += 2 * RGB_PIXELSIZE;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr = *fgptr++;
    }
    inline 
        void mask_pixel_assign_1_10(Asd::UInt8 * outptr, Asd::UInt8 *fgptr){
        
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        outptr += RGB_PIXELSIZE;
        outptr += RGB_PIXELSIZE;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr = *fgptr++;
    }
    inline 
        void mask_pixel_assign_1_11(Asd::UInt8 * outptr, Asd::UInt8 *fgptr){
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        outptr +=  RGB_PIXELSIZE;
        fgptr +=  RGB_PIXELSIZE;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;     
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr = *fgptr++;
    }
    inline 
        void mask_pixel_assign_1_12(Asd::UInt8 * outptr, Asd::UInt8 *fgptr){
        
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
    }
    inline 
        void mask_pixel_assign_1_13(Asd::UInt8 * outptr, Asd::UInt8 *fgptr){
        
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        
        outptr +=  RGB_PIXELSIZE;
        fgptr +=  RGB_PIXELSIZE;
        
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr = *fgptr++;
    }
    inline 
        void mask_pixel_assign_1_14(Asd::UInt8 * outptr, Asd::UInt8 *fgptr){
        
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
    }
    inline 
        void mask_pixel_assign_1_15(Asd::UInt8 * outptr, Asd::UInt8 *fgptr){
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        *outptr++ = *fgptr++;
        
    }
    
    
    void (*mask_pixel_assign1[16])(Asd::UInt8 * outptr, Asd::UInt8 *fgptr) =
    {
        mask_pixel_assign_1_0,  
            mask_pixel_assign_1_1,  mask_pixel_assign_1_2 ,  mask_pixel_assign_1_3,
            mask_pixel_assign_1_4,  mask_pixel_assign_1_5 ,  mask_pixel_assign_1_6,
            mask_pixel_assign_1_7,  mask_pixel_assign_1_8 ,  mask_pixel_assign_1_9,
            mask_pixel_assign_1_10,  mask_pixel_assign_1_11 ,  mask_pixel_assign_1_12,
            mask_pixel_assign_1_13,  mask_pixel_assign_1_14 ,  mask_pixel_assign_1_15
    };
    
    
#ifdef __cplusplus
}
#endif

#endif /* ___MASK_TABLE_H___ */
