VERSION 5.00
Begin VB.Form BmpOptions 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Save Page as .bmp"
   ClientHeight    =   2700
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   4800
   Icon            =   "BmpOptions.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2700
   ScaleWidth      =   4800
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   WhatsThisButton =   -1  'True
   WhatsThisHelp   =   -1  'True
   Begin VB.TextBox Text3 
      Appearance      =   0  'Flat
      BackColor       =   &H8000000F&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   480
      TabIndex        =   7
      Text            =   "Zoom"
      ToolTipText     =   "Zoom to be Saved at"
      Top             =   1155
      WhatsThisHelpID =   22
      Width           =   735
   End
   Begin VB.TextBox Text1 
      Appearance      =   0  'Flat
      BackColor       =   &H8000000F&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   480
      TabIndex        =   6
      Text            =   "Page"
      ToolTipText     =   "Page to be Saved"
      Top             =   555
      WhatsThisHelpID =   20
      Width           =   735
   End
   Begin VB.TextBox Zoom 
      Alignment       =   1  'Right Justify
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1800
      TabIndex        =   5
      Text            =   "100%"
      ToolTipText     =   "Zoom to be Saved at"
      Top             =   1080
      WhatsThisHelpID =   22
      Width           =   975
   End
   Begin VB.TextBox Page 
      Alignment       =   1  'Right Justify
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1800
      TabIndex        =   4
      Text            =   "1"
      ToolTipText     =   "Page to be Saved"
      Top             =   480
      WhatsThisHelpID =   20
      Width           =   975
   End
   Begin VB.CommandButton helpButton 
      Caption         =   "Help"
      Height          =   375
      Left            =   3360
      TabIndex        =   2
      ToolTipText     =   "Show Help"
      Top             =   480
      Width           =   1215
   End
   Begin VB.CommandButton CancelButton 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3360
      TabIndex        =   1
      ToolTipText     =   "Exit Dialog Without Saving"
      Top             =   1680
      Width           =   1215
   End
   Begin VB.CommandButton SaveButton 
      Caption         =   "Save..."
      Height          =   375
      Left            =   3360
      TabIndex        =   0
      ToolTipText     =   "Save to .bmp"
      Top             =   1080
      Width           =   1215
   End
   Begin VB.Frame Frame1 
      Height          =   2295
      Left            =   240
      TabIndex        =   3
      Top             =   120
      Width           =   2775
      Begin VB.ComboBox Layer 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   360
         Left            =   240
         Style           =   2  'Dropdown List
         TabIndex        =   8
         Top             =   1680
         WhatsThisHelpID =   21
         Width           =   2295
      End
   End
End
Attribute VB_Name = "BmpOptions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'The only time this form should ever be created is when
'a SilxDoc wants to save a page in Windows bitmap (.bmp)
'format.  The form should be created hidden.  After being
'created, the SilxDoc should call Init() so that BmpOptions
'can fill itself with the correct information when it is
'first shown and so that it can access the required additional
'information later.
'
' BmpOptions boxes should be Modal so that the SilxDoc to which
' they refer does not change underneath them.
'
' Here is what the code to save as .bmp will usually look like.
'
'...
'
'   Dim bmpOpts As New BmpOptions
'   bmpOpts.Init Me          'Me is a SilxDoc
'   bmpOpts.Show 1           'BmpOptions should be modal.
'
'...

'docRef is a reference to the SilxDoc that created us.  It gets set in
'the Init() function.
'
Dim docRef As SilxDoc

'fixLayers() checks to see if the number of layers in the Layer list
'box is consistant with the current choice of page from the page text
'box.  If not, it fixes the Layer list box so that it is consistant.
'
'Any time the Layer list box has to be rebuilt, the current layer is
'set to "Composite."  The idea is that current layer is undefined if
'you view a page with a different number of layers than the page
'you were viewing.  The simplist way of dealing with this seemed to
'be to pick composite as a default to return to.
'
Sub fixLayers()

    If Not docRef.SilxCtl.IsSilx Then
    
        Me.Layer.Visible = False
        
    Else
        
        Me.Layer.Visible = True
       
        Dim pg, numLayers As Long
            
        pg = Val(Me.Page.Text)
        numLayers = docRef.SilxCtl.LayersOnPage(pg)
            
        'If pg is out of bounds, we do not want to update anything.  The
        'user is probably in the middle of making a change.
        If ((pg > 0) And (pg <= docRef.SilxCtl.NumPages)) Then
        
            'Do we need to fix anything?  Remember that there
            'is one extra entry in the Layer list box because it
            'has "Composite" in addition to each layer.
            If Not (numLayers = (Me.Layer.ListCount - 1)) Then
        
                Me.Layer.Clear
                Me.Layer.AddItem "Composite"
        
                Dim ll As Long
            
                For ll = 1 To numLayers
        
                    Me.Layer.AddItem "Layer " & Str(ll)
            
                Next ll
            
                Me.Layer.ListIndex = 0
                
            End If
        End If
    End If

End Sub

'Init sets docRef to refer to dr.  It then initializes all of the
'values in the BmpOptions form.  After calling init, it is ready
'for display.
'
'The values BmpOptions is initialized with are the values from the
'current view state of the image.  Thus, if I am currently viewing
'layer 2 of page three at 25% zoom, I will see these values as the
'choices when I first show BmpOptions.
'
Sub Init(ByRef dr As SilxDoc)

    Set docRef = dr
    
    'Get rid of any old state.
    Me.Layer.Clear
    
    'Note that setting the page will cause a Page_Change event that
    'will fix the Layer list box.
    Me.Page.Text = Str(docRef.SilxCtl.CurrentPage)
    
    'If we have a .tfx file, we set the layer to be the current layer.
    If docRef.SilxCtl.IsSilx Then
        
        'Now that the entries in the Layer list box are correct
        'set the selection to the current layer.
        Me.Layer.ListIndex = docRef.Layer.ListIndex
    
    End If

    Me.Zoom.Text = Str(docRef.SilxCtl.ZoomFactor * 100) & "%"
    

End Sub

'Because the page and zoom are free-response text boxes,
'it is possible the user has entered garbage.  validageInput()
'does four things:
'
' 1.  It parses the text in the Page and Zoom text boxes.

' 2.  It checks these values and returns true if all as well or false
'     if there is a problem.
'
' 3.  It displays a message box explaining the problem it found.
'
' 4.  If all is well, it puts the numeric values of page and zoom in
'     the pageVal and zoomVal arguments.
'
Private Function validateInput(ByRef dr As SilxDoc, pageVal As Long, ByRef zoomVal As Double) As Boolean

    If (IsNumeric(Me.Page.Text)) Then
    
        pageVal = Val(Me.Page.Text)
        
        If ((pageVal < 1) Or (pageVal > dr.SilxCtl.NumPages)) Then
        
            MsgBox "Page must be in range [1, " & Str(docRef.SilxCtl.NumPages) & "]"
            validateInput = False
            Exit Function
        
        End If
    Else
    
        MsgBox "Page must be a number!"
        validateInput = False
        Exit Function
        
    End If
        
    zoomVal = PercentToDecimal(Me.Zoom.Text)
    
    If ((zoomVal < 0.01) Or (zoomVal > 1)) Then
        
        MsgBox "Zoom must be a percentage between 1% and 100%."
        validateInput = False
        Exit Function
        
    End If
        
    validateInput = True
    
End Function


'If the user clicks cancel, the BmpOptions box goes away without
'saving as a .bmp file.
'
Private Sub CancelButton_Click()

    Unload Me
        
End Sub


'Display help if the user clicks the help button.
'
Private Sub helpButton_Click()

    Help.DisplayHelpContents

End Sub

'If the page has changed we may need to fix the Layer list box.
'to be correct for the new page.
'
Private Sub Page_Change()

    Me.fixLayers

End Sub

'The user has accepted the options and wants to save as .bmp.
'Check to make sure the options are valid.  If not, inform
'the user and leave the box on the screen.
'
'If all is well, hide (but do no Unload!) the BmpOptions box
'and use the CommonDialog box to select the file to save as.
'When everything is done, unload BmpOptions.
'
Private Sub SaveButton_Click()

    Dim pageVal As Long
    Dim zoomVal As Double
    Dim layerVal As Long
        
    If (validateInput(docRef, pageVal, zoomVal)) Then
        
        If docRef.SilxCtl.IsSilx Then
        
            layerVal = Me.Layer.ListIndex
            
        Else
        
            layerVal = 0
            
        End If
        
        Me.Hide
        
        Dim dotPos As Long
    
        dotPos = InStrRev(docRef.SilxCtl.fileName, ".")
    
        If (dotPos > 0) Then
    
            docRef.ComDlg.fileName = Left(docRef.SilxCtl.fileName, dotPos - 1)
            
        Else
        
            docRef.ComDlg.fileName = docRef.SilxCtl.fileName
        
        End If
        
        docRef.ComDlg.fileName = docRef.ComDlg.fileName & "_page" & Str(pageVal) & ".bmp"
    
        'Since we are saving as .bmp, set up the filter to show
        '.bmp files.
        docRef.ComDlg.Filter = "Windows Bitmap (*.bmp)|*.bmp"
        docRef.ComDlg.DefaultExt = "bmp"
        
        docRef.ComDlg.CancelError = True
        docRef.ComDlg.Flags = cdlOFNHideReadOnly Or cdlOFNOverwritePrompt
    
        On Error GoTo Skip
        
        docRef.ComDlg.ShowSave
    
        If Not (docRef.ComDlg.fileName = "") Then
    
            docRef.Refresh 'Make page look nice while we save.
            
            'All is well, so save the page as .bmp
            docRef.SilxCtl.SavePageAsBmp docRef.ComDlg.fileName, pageVal, layerVal, zoomVal
        
        End If
    
Skip:
        Unload Me
    
    End If

End Sub

