#ifndef DECODE_COLORS_H
#define DECODE_COLORS_H

#include "color-extension.h"

#ifdef __cplusplus
extern "C"
{
#endif

extern ErrCode
decodeColorsIndexed(color_cookie *ccookie, void *colorbuf, size_t colorbuflen, 
					Dgp_Int32 **_tag_index, Dgp_Int32 *_num_tag_index, color_tag **_unique_tags, Dgp_Int32 *_num_unique);

extern ErrCode
decodeColors(color_cookie *ccookie, void *colorbuf, size_t colorbuflen, 
			 color_tag **_tags, Dgp_Int32 *_num_tags, Dgp_Int32 *_num_unique);

extern ErrCode
decodeJbig2Colors(color_cookie *ccookie, void *colorbuf, size_t colorbuflen,
                         color_tag **_tags, Dgp_Int32 *_num_tags);

#ifdef __cplusplus
}
#endif

#endif
