#ifndef ENCODE_COLORS_H
#define ENCODE_COLORS_H

#include <stdio.h>
#include <mmcompress.h>
#include "color-extension.h"

#define NCOMP 3
#define COMPLEN 1
#define MAX_RUN_LEN 65535
#define MIN_RUN_LEN 255


#ifdef __cplusplus
extern "C"
{
#endif

extern ErrCode
encodeColors(tokpos **sorted_tokens, Dgp_Int32 ntok, void *extcookie,
			 void **extension, size_t *extlen);
extern ErrCode
encodeJbig2Colors(tokpos **sorted_tokens, Dgp_Int32 ntok, void *extcookie,
			 void **extension, size_t *extlen, Dgp_State *dgp_state);

#ifdef __cplusplus
}
#endif

#endif
