/*************************************************************************
**
**  DigiPaper Codebase
**    
**  James Ahlborn, February 1 1998
**
**  Filename: cccrun_t.h
**
**  Description of what's implemented in this file:
**    color connected component run type
**  
**************************************************************************/

/*
 * $Header: /project/icons/cvsroot/digipaper/src/libcomponent/cccrun_t.h,v 1.2 2000/03/04 00:22:19 mkrocken Exp $
 */


#ifndef __CCCRUN_T_H
#define __CCCRUN_T_H

#include "image.h"

#ifdef __cplusplus
extern "C"
{
#endif


typedef struct {
  union {
	  DgpImage_RGB *rgb;
	  Dgp_UInt32 *cmyk;
  } sampling;
  Dgp_UInt32  color;
  Dgp_UInt16 length;
  Dgp_Int8 sampled;
} cccRun;


#ifdef __cplusplus
}
#endif

#endif /* __CCCRUN_T_H */
