/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libimage/image-private.h,v 1.3 2003/02/10 22:53:25 mkrocken Exp $
 *
 */

#ifndef	IMAGE_PRIVATE_H

#define	IMAGE_PRIVATE_H

#include "image.h"


/* functions that operate on unpacked images */

/*extern ErrCode 
DgpImage_unp_New (Dgp_State *dgp_state, DgpImage_Type type, Dgp_Int32 width, Dgp_Int32 height, void **retim);

extern ErrCode 
DgpImage_unp_NewOffset(Dgp_State *dgp_state, DgpImage_Type type, Dgp_Int32 width, Dgp_Int32 height, 
				   Dgp_Int32 xbase, Dgp_Int32 ybase, void **retim);

extern ErrCode 
DgpImage_unp_Free_(void *im, DgpImage_Header *header);

extern ErrCode 
DgpImage_unp_SetOffset_(void *im, DgpImage_Header *header, Dgp_Int32 newxbase, 
					 Dgp_Int32 newybase); */

/* Moved these to image.h / dhtesq. */
/*
extern ErrCode
DgpImage_pLoadF (Dgp_State *dpg_state, DgpImage_Type type, FILE *inFile, void** image);

extern ErrCode
DgpImage_pSaveF (void *im, FILE *outFile);
*/
/* extern ErrCode
DgpImage_pPromote (void *im, DgpImage_Type promoteto, void** image);

extern ErrCode
DgpImage_pDemote (void *im, DgpImage_Type demoteto, void** image);

extern ErrCode 
DgpImage_unp_Load(Dgp_State *dgp_state, DgpImage_Type type, Dgp_Int8 *filename, void **retim);

extern ErrCode 
DgpImage_unp_LoadF(Dgp_State *dgp_state, DgpImage_Type type, FILE *inFile, void **retim);

extern ErrCode 
DgpImage_unp_Save_(void *im, DgpImage_Header *header, Dgp_Int8 *filename);

extern ErrCode
DgpImage_unp_SaveF_(void *im, DgpImage_Header *header, FILE *outFile);

extern ErrCode
DgpImage_unp_Dup_(void *im, DgpImage_Header *header, Dgp_Bool copycomment,
			   void** retim);

extern ErrCode 
DgpImage_unp_Promote_(void *im, DgpImage_Header *header, 
				   DgpImage_Type promoteto, void **retim);

extern ErrCode
DgpImage_unp_SetPromotion(Dgp_State *dgp_state, DgpImage_Type promotefrom, DgpImage_Type promoteto,
				      double slope, double offset);

extern ErrCode 
DgpImage_unp_Demote_(void *im, DgpImage_Header *header, 
				  DgpImage_Type demoteto, void **retim);

extern ErrCode
DgpImage_unp_Convert_(void *im, DgpImage_Header *header, 
				   DgpImage_Type convertto, void **retim); */


/* A bunch of reader functions */
extern Dgp_Bool DgpImage_readGrayRaw(DgpImage_Gray im, Dgp_Int32 width, Dgp_Int32 height,
			       FILE *inFile, DgpImage_Type endian);
extern Dgp_Bool DgpImage_readFloatRaw(DgpImage_Float im, Dgp_Int32 width, Dgp_Int32 height,
				FILE *inFile, DgpImage_Type endian);
extern Dgp_Bool DgpImage_readRGBRaw(DgpImage_ColorRGB im, Dgp_Int32 width, Dgp_Int32 height,
			      FILE *inFile, DgpImage_Type endian);
extern Dgp_Bool DgpImage_readDoubleRaw(DgpImage_Double im, Dgp_Int32 width, Dgp_Int32 height,
				 FILE *inFile, DgpImage_Type endian);
extern Dgp_Bool DgpImage_readBinaryRaw(DgpImage_Binary im, Dgp_Int32 width, Dgp_Int32 height,
				 FILE *inFile, DgpImage_Type endian);
extern Dgp_Bool DgpImage_readLongRaw(DgpImage_Long im, Dgp_Int32 width, Dgp_Int32 height,
			       FILE *inFile, DgpImage_Type endian);
extern Dgp_Bool DgpImage_readShortRaw(DgpImage_Short im, Dgp_Int32 width, Dgp_Int32 height,
				FILE *inFile, DgpImage_Type endian);
extern Dgp_Bool DgpImage_readRGBFloatRaw(DgpImage_ColorRGBFloat im,
				   Dgp_Int32 width, Dgp_Int32 height,
				   FILE *inFile, DgpImage_Type endian);
extern Dgp_Bool DgpImage_readPackedRaw(DgpImage_Packed im, Dgp_Int32 width, Dgp_Int32 height,
				 FILE *inFile, DgpImage_Type endian);

/* and writer functions */
extern Dgp_Bool DgpImage_saveGrayRaw(DgpImage_Gray im, FILE *outFile,
			       DgpImage_Type endian);
extern Dgp_Bool DgpImage_saveFloatRaw(DgpImage_Float im, FILE *outFile,
				DgpImage_Type endian);
extern Dgp_Bool DgpImage_saveRGBRaw(DgpImage_ColorRGB im, FILE *outFile,
			      DgpImage_Type endian);
extern Dgp_Bool DgpImage_saveDoubleRaw(DgpImage_Double im, FILE *outFile,
				 DgpImage_Type endian);
extern Dgp_Bool DgpImage_saveBinaryRaw(DgpImage_Binary im, FILE *outFile,
				 DgpImage_Type endian);
extern Dgp_Bool DgpImage_saveLongRaw(DgpImage_Long im, FILE *outFile,
			       DgpImage_Type endian);
extern Dgp_Bool DgpImage_saveShortRaw(DgpImage_Short im, FILE *outFile,
				DgpImage_Type endian);
extern Dgp_Bool DgpImage_saveRGBFloatRaw(DgpImage_ColorRGBFloat im, FILE *outFile,
				   DgpImage_Type endian);
extern Dgp_Bool DgpImage_savePackedRaw(DgpImage_Packed im, FILE *outFile,
				 DgpImage_Type endian);

#endif
