
#ifndef MRCIO_H
#define MRCIO_H

#include <stdio.h>
#include "nt_compat.h"
#include "dgp_types.h"
#include "uds.h"

typedef struct {
    FILE *fp;
    Dgp_Int32 pos;
    uds   *u;
} FileID;

Dgp_Int32 TC_CDECL 
fileRead(Dgp_UInt32 fileID, Dgp_Int8 *buffer, Dgp_Int32 byteCount);
Dgp_Int32 TC_CDECL 
fileWrite(Dgp_UInt32 fileID, Dgp_Int8 *buffer, Dgp_Int32 byteCount);
Dgp_Int32 TC_CDECL 
fileSeek(Dgp_UInt32 fileID, Dgp_Int32 offset);
Dgp_Int32 TC_CDECL 
fileFileSize(Dgp_UInt32 fileID);
Dgp_Int32 TC_CDECL 
fileTell(Dgp_UInt32 fileID);


Dgp_Int32 TC_CDECL 
ibufRead(Dgp_UInt32 bufID, Dgp_Int8 *buffer, Dgp_Int32 byteCount);
Dgp_Int32 TC_CDECL 
ibufWrite(Dgp_UInt32 bufID, Dgp_Int8 *buffer, Dgp_Int32 byteCount);
Dgp_Int32 TC_CDECL 
ibufSeek(Dgp_UInt32 bufID, Dgp_Int32 offset);
Dgp_Int32 TC_CDECL 
ibufFileSize(Dgp_UInt32 bufID);
Dgp_Int32 TC_CDECL 
ibufTell(Dgp_UInt32 bufID);

#endif
