

#include "dgp_types.h"
#include "dgp_state.h"
#include "list.h"

#include "mrc2file.h"

#ifndef JBIG2FILE_H
#define JBIG2FILE_H

/* open a JBIG2 file and return a pointer to the data structure */
ErrCode
Dgp_createJbig2Stream (Dgp_State *dgp_state, uds *u, 
			      Dgp_CompressedDocument **cDocument);

/* close the JBIG2 file and free all remaining memory */
ErrCode
Dgp_closeJbig2Stream (Dgp_CompressedDocument *cDocument);

/* write a section to file and free all memory associated with this section */
ErrCode
Dgp_writeSectionJbig2Only (Dgp_CompressedDocument *cDocument, Dgp_Bool clear_dict);



/* open a JBIG2 file and return a pointer to the data structure */
ErrCode
Dgp_createPDFStream (Dgp_State *dgp_state, uds *u, 
			      Dgp_CompressedDocument **cDocument);

/* close the JBIG2 file and free all remaining memory */
ErrCode
Dgp_closePDFStream (Dgp_CompressedDocument *cDocument);

/* write a section to file and free all memory associated with this section */
ErrCode
Dgp_writePDFData (Dgp_CompressedDocument *cDocument);

#endif
