/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/decint.h,v 1.11 2002/05/30 02:42:46 jlin Exp $
 *
 */

#ifndef	DECINT_H

#define	DECINT_H

#include "hufftable.h"
#include "jbitfile.h"
#include "mqcoder.h"

#ifdef __cplusplus
extern "C"
{
#endif

/*
 * An integer decoder
 */
typedef struct _diDecoder *diDecoder;
#define	NULLDIDECODER	((diDecoder)NULL)

extern ErrCode diNewDecoder(const hufftable_spec *spec, jbitfile file,
			      Dgp_State *dgp_state, diDecoder *newd);
#ifndef	NOMQ
extern ErrCode diNewDecoderMQ(DgpEncode_MQDecoder *mqdec, Dgp_UInt8 *contexts,
			      Dgp_State *dgp_state, diDecoder *newd);
#endif
extern ErrCode diNewDecoderEither(Dgp_Bool huff,
				    const hufftable_spec *spec, jbitfile file,
				    DgpEncode_MQDecoder *mqdec, Dgp_UInt8 *contexts,
				    Dgp_State *dgp_state, diDecoder *newd);
extern ErrCode diDecode(diDecoder dec, Dgp_Bool *oob, Dgp_Int32 *val);
extern void diFreeDecoder(diDecoder dec);

/* How many bytes of contexts you need for diNewDecoderMQ */
#define	DICONTEXTSIZE	512

#ifdef __cplusplus
}
#endif

#endif
