/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/encgenreg.h,v 1.11 2002/05/30 02:42:46 jlin Exp $
 *
 */

#ifndef	ENCGENREG_H

#define	ENCGENREG_H

#include "util.h"
#include "jb2file.h"
#include "params.h"
#include "mqcoder.h"
#include <stdlib.h>
#include "segment.h"
#include "image.h"

#ifdef __cplusplus
extern "C"
{
#endif

extern ErrCode jb2EncodeGenRegion(jb2File file, jb2Segment *segment);

extern ErrCode jb2MMREncode(Dgp_UInt32 *bitmap, Dgp_Int32 width, Dgp_Int32 height,
			    Dgp_Int32 Dgp_Int32sperline,
			    Dgp_UInt8 *data, size_t *datalen,
			    Dgp_Bool writeEOFB, Dgp_State *dgp_state);
extern ErrCode jb2MMREncodeDS(jb2File file, DataSink data,
			      Dgp_UInt32 *bitmap, Dgp_Int32 width, Dgp_Int32 height,
			      Dgp_Int32 Dgp_Int32sperline,
			      Dgp_Bool writeEOFB);
#ifndef	NOMQ
extern ErrCode jb2ArithEncodeImage(Dgp_UInt32 *bitmap,
				   Dgp_Int32 width, Dgp_Int32 height, Dgp_Int32 Dgp_Int32sperline,
				   arith_bitmap_params *params,
				   Dgp_UInt8 *contexts,
				   jb2File file, DgpEncode_MQEncoder *enc);
extern ErrCode jb2ArithEncodeImagePacked(DgpImage_Packed src,
					 arith_bitmap_params *params,
					 Dgp_UInt8 *contexts,
					 DgpEncode_MQEncoder *enc,
					 Dgp_State *dgp_state);
#endif

/* Utility routine for encoding arith bitmap params */
extern ErrCode jb2EncodeABParams(jb2File file, DataSink data,
				 arith_bitmap_params *params);

#ifdef __cplusplus
}
#endif

#endif
