/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/hufftable_util.h,v 1.10 2002/05/30 02:42:46 jlin Exp $
 *
 */

#ifndef	HUFFTABLE_UTIL_H

#define	HUFFTABLE_UTIL_H

#ifdef __cplusplus
extern "C"
{
#endif

extern ErrCode jhtGetCodeLengths(Dgp_Int32 *counts, Dgp_Int32 *lengths, Dgp_Int32 ncounts,
				 Dgp_State *dgp_state);
extern ErrCode jhtTuneTable(hufftable_spec *spec, Dgp_Int32 *counts, Dgp_Int32 *lengths,
			    Dgp_State *dgp_state);
extern ErrCode jhtTuneNumericTable(hufftable_spec *spec, Dgp_Int32 *counts,
				   Dgp_Int32 *lengths, Dgp_State *dgp_state);
extern ErrCode jhtTuneStandardTable(hufftable_spec *spec, Dgp_Int32 *counts,
				    Dgp_Int32 *lengths, Dgp_State *dgp_state,
				    hufftable_spec **newspec);
extern ErrCode jhtCountBits(hufftable_spec *spec, Dgp_Int32 *counts, Dgp_Int32 *lengths,
			    Dgp_Int32 *normalbits, Dgp_Int32 *tunedbits,
			    Dgp_State *dgp_state);
ErrCode jhtAllocTableInfo(hufftable_spec **tables, Dgp_Int32 **lengths, Dgp_Int32 **counts,
			  eiEncoder *eis, Dgp_Int32 ntables, Dgp_State *dgp_state);
ErrCode jhtDecideTable(hufftable_spec **tables, Dgp_Int32 **counts, Dgp_Int32 **lengths,
		       Dgp_Int32 *normal, Dgp_Int32 *tuned, Dgp_Bool *bestnew,
		       hufftable_spec **bestTable, Dgp_Int32 ntables,
		       Dgp_Bool custom_allowed, Dgp_State *dgp_state);

#ifdef __cplusplus
}
#endif

#endif
