/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/params.h,v 1.5 2002/05/30 02:42:47 jlin Exp $
 *
 */

#ifndef	PARAMS_H

#define	PARAMS_H

/* Some generic parameter structures that don't depend on anything */

#include "util.h"
#ifdef __cplusplus
extern "C"
{
#endif

/* Parameters for controlling how to arithmetically code a bitmap */
typedef struct _arith_bitmap_params {
    Dgp_UInt8 rtemplate;
    Dgp_Int8 atx[4], aty[4];
    Dgp_Bool tpon;
    } arith_bitmap_params;

/* Parameters for controlling how to arithmetically code using refinement */
typedef struct _arith_ref_params {
    Dgp_UInt8 rtemplate;
    Dgp_Int8 ratx[2], raty[2];
    Dgp_Bool tpron;
    } arith_ref_params;

#ifdef __cplusplus
}
#endif

#endif
