#include "util.h"
#include "jinclude.h"
#include "jpeg6blib.h"
#include <assert.h>
#include <math.h>

INLINE
void pixel_assign_4_0(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val){
    (void)outptr;
}
INLINE 
void pixel_assign_4_1(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val){

      outptr += 3* RGB_PIXELSIZE;
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr = b_val;
}

INLINE 
void pixel_assign_4_2(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val){

      outptr += 2 * RGB_PIXELSIZE;
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr = b_val;

}
INLINE 
void pixel_assign_4_3(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val){

      outptr += 2 * RGB_PIXELSIZE;
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr = b_val;

}
INLINE 
void pixel_assign_4_4(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val){

      outptr += RGB_PIXELSIZE;
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr = b_val;

}
INLINE 
void pixel_assign_4_5(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val){

      outptr += RGB_PIXELSIZE;
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
      outptr +=  RGB_PIXELSIZE;
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr = b_val;

}
INLINE 
void pixel_assign_4_6(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val){

      outptr += RGB_PIXELSIZE;
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr = b_val;
}
INLINE 
void pixel_assign_4_7(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val){
      outptr += RGB_PIXELSIZE;
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr = b_val;
}
INLINE 
void pixel_assign_4_8(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val){

	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr = b_val;
}
INLINE 
void pixel_assign_4_9(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val){
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
      outptr += 2* RGB_PIXELSIZE;
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr = b_val;
}
INLINE 
void pixel_assign_4_10(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val){

	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
      outptr += RGB_PIXELSIZE;
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr = b_val;
}
INLINE 
void pixel_assign_4_11(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val){
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
      outptr +=  RGB_PIXELSIZE;
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;     
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr = b_val;
}
INLINE 
void pixel_assign_4_12(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val){
  
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;

      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr = b_val;
}
INLINE 
void pixel_assign_4_13(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val){
	  
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
	  
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;

      outptr +=  RGB_PIXELSIZE;
      
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr = b_val;
}
INLINE 
void pixel_assign_4_14(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val){
        
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
	  
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
	  
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr = b_val;
}
INLINE 
void pixel_assign_4_15(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val){
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
	  
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
	  
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
	  
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr = b_val;
}

void (*pixel_assign4[16])(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val) =
{
    pixel_assign_4_0,  
    pixel_assign_4_1,  pixel_assign_4_2 ,  pixel_assign_4_3,
    pixel_assign_4_4,  pixel_assign_4_5 ,  pixel_assign_4_6,
    pixel_assign_4_7,  pixel_assign_4_8 ,  pixel_assign_4_9,
    pixel_assign_4_10,  pixel_assign_4_11 ,  pixel_assign_4_12,
    pixel_assign_4_13,  pixel_assign_4_14 ,  pixel_assign_4_15
};




/********************************************************************************************************************/


INLINE
void pixel_assign_2_0(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val, Dgp_UInt8 r_val2, Dgp_UInt8 g_val2, Dgp_UInt8 b_val2){
    (void) outptr;
}
INLINE 
void pixel_assign_2_1(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val, Dgp_UInt8 r_val2, Dgp_UInt8 g_val2, Dgp_UInt8 b_val2){

      outptr += 3* RGB_PIXELSIZE;
	  *outptr++ = r_val2;
	  *outptr++ = g_val2;
	  *outptr = b_val2;
}

INLINE 
void pixel_assign_2_2(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val, Dgp_UInt8 r_val2, Dgp_UInt8 g_val2, Dgp_UInt8 b_val2){

      outptr += 2 * RGB_PIXELSIZE;
	  *outptr++ = r_val2;
	  *outptr++ = g_val2;
	  *outptr = b_val2;

}
INLINE 
void pixel_assign_2_3(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val, Dgp_UInt8 r_val2, Dgp_UInt8 g_val2, Dgp_UInt8 b_val2){

      outptr += 2 * RGB_PIXELSIZE;
      *outptr++ = r_val2;
	  *outptr++ = g_val2;
	  *outptr++ = b_val2;
	  *outptr++ = r_val2;
	  *outptr++ = g_val2;
	  *outptr = b_val2;

}
INLINE 
void pixel_assign_2_4(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val, Dgp_UInt8 r_val2, Dgp_UInt8 g_val2, Dgp_UInt8 b_val2){

      outptr += RGB_PIXELSIZE;
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr = b_val;

}
INLINE 
void pixel_assign_2_5(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val, Dgp_UInt8 r_val2, Dgp_UInt8 g_val2, Dgp_UInt8 b_val2){

      outptr += RGB_PIXELSIZE;
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
      outptr +=  RGB_PIXELSIZE;
	  *outptr++ = r_val2;
	  *outptr++ = g_val2;
	  *outptr = b_val2;

}
INLINE 
void pixel_assign_2_6(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val, Dgp_UInt8 r_val2, Dgp_UInt8 g_val2, Dgp_UInt8 b_val2){

      outptr += RGB_PIXELSIZE;
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
	  *outptr++ = r_val2;
	  *outptr++ = g_val2;
	  *outptr = b_val2;
}
INLINE 
void pixel_assign_2_7(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val, Dgp_UInt8 r_val2, Dgp_UInt8 g_val2, Dgp_UInt8 b_val2){
      outptr += RGB_PIXELSIZE;
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
	  *outptr++ = r_val2;
	  *outptr++ = g_val2;
	  *outptr++ = b_val2;
	  *outptr++ = r_val2;
	  *outptr++ = g_val2;
	  *outptr = b_val2;
}
INLINE 
void pixel_assign_2_8(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val, Dgp_UInt8 r_val2, Dgp_UInt8 g_val2, Dgp_UInt8 b_val2){

	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr = b_val;
}
INLINE 
void pixel_assign_2_9(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val, Dgp_UInt8 r_val2, Dgp_UInt8 g_val2, Dgp_UInt8 b_val2){
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
      outptr += 2* RGB_PIXELSIZE;
	  *outptr++ = r_val2;
	  *outptr++ = g_val2;
	  *outptr = b_val2;
}
INLINE 
void pixel_assign_2_10(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val, Dgp_UInt8 r_val2, Dgp_UInt8 g_val2, Dgp_UInt8 b_val2){

	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
      outptr += RGB_PIXELSIZE;
	  *outptr++ = r_val2;
	  *outptr++ = g_val2;
	  *outptr = b_val2;
}
INLINE 
void pixel_assign_2_11(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val, Dgp_UInt8 r_val2, Dgp_UInt8 g_val2, Dgp_UInt8 b_val2){
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
      outptr +=  RGB_PIXELSIZE;
	  *outptr++ = r_val2;
	  *outptr++ = g_val2;
	  *outptr++ = b_val2;     
      *outptr++ = r_val2;
	  *outptr++ = g_val2;
	  *outptr = b_val2;
}
INLINE 
void pixel_assign_2_12(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val, Dgp_UInt8 r_val2, Dgp_UInt8 g_val2, Dgp_UInt8 b_val2){
  
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;

      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr = b_val;
}
INLINE 
void pixel_assign_2_13(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val, Dgp_UInt8 r_val2, Dgp_UInt8 g_val2, Dgp_UInt8 b_val2){
	  
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
	  
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;

      outptr +=  RGB_PIXELSIZE;
      
      *outptr++ = r_val2;
	  *outptr++ = g_val2;
	  *outptr = b_val2;
}
INLINE 
void pixel_assign_2_14(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val, Dgp_UInt8 r_val2, Dgp_UInt8 g_val2, Dgp_UInt8 b_val2){
        
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
	  
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
	  
      *outptr++ = r_val2;
	  *outptr++ = g_val2;
	  *outptr = b_val2;
}
INLINE 
void pixel_assign_2_15(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val, Dgp_UInt8 r_val2, Dgp_UInt8 g_val2, Dgp_UInt8 b_val2){
	  *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
	  
      *outptr++ = r_val;
	  *outptr++ = g_val;
	  *outptr++ = b_val;
	  
      *outptr++ = r_val2;
	  *outptr++ = g_val2;
	  *outptr++ = b_val2;
	  
      *outptr++ = r_val2;
	  *outptr++ = g_val2;
	  *outptr = b_val2;
}


void (*pixel_assign2[16])(JSAMPROW outptr, Dgp_UInt8 r_val, Dgp_UInt8 g_val, Dgp_UInt8 b_val,
                          Dgp_UInt8 r_val2, Dgp_UInt8 g_val2, Dgp_UInt8 b_val2) =
{
    pixel_assign_2_0,  
    pixel_assign_2_1,  pixel_assign_2_2 ,  pixel_assign_2_3,
    pixel_assign_2_4,  pixel_assign_2_5 ,  pixel_assign_2_6,
    pixel_assign_2_7,  pixel_assign_2_8 ,  pixel_assign_2_9,
    pixel_assign_2_10,  pixel_assign_2_11 ,  pixel_assign_2_12,
    pixel_assign_2_13,  pixel_assign_2_14 ,  pixel_assign_2_15
};



/********************************************************************************************************************/


INLINE
void pixel_assign_1_0(JSAMPROW outptr, Dgp_UInt8 *r_val, Dgp_UInt8 *g_val, Dgp_UInt8 *b_val){
    (void)outptr;
    (void)r_val;
    (void)g_val;
    (void)b_val;
}
INLINE 
void pixel_assign_1_1(JSAMPROW outptr, Dgp_UInt8 *r_val, Dgp_UInt8 *g_val, Dgp_UInt8 *b_val){

      outptr += 3* RGB_PIXELSIZE;
	  *outptr++ = r_val[3];
	  *outptr++ = g_val[3];
	  *outptr = b_val[3];
}

INLINE 
void pixel_assign_1_2(JSAMPROW outptr, Dgp_UInt8 *r_val, Dgp_UInt8 *g_val, Dgp_UInt8 *b_val){

      outptr += 2 * RGB_PIXELSIZE;
	  *outptr++ = r_val[2];
	  *outptr++ = g_val[2];
	  *outptr = b_val[2];

}
INLINE 
void pixel_assign_1_3(JSAMPROW outptr, Dgp_UInt8 *r_val, Dgp_UInt8 *g_val, Dgp_UInt8 *b_val){

      outptr += 2 * RGB_PIXELSIZE;
      *outptr++ = r_val[2];
	  *outptr++ = g_val[2];
	  *outptr++ = b_val[2];
	  *outptr++ = r_val[3];
	  *outptr++ = g_val[3];
	  *outptr = b_val[3];

}
INLINE 
void pixel_assign_1_4(JSAMPROW outptr, Dgp_UInt8 *r_val, Dgp_UInt8 *g_val, Dgp_UInt8 *b_val){

      outptr += RGB_PIXELSIZE;
      *outptr++ = *(++r_val);
	  *outptr++ = *(++g_val);
	  *outptr++ = *(++b_val);

}
INLINE 
void pixel_assign_1_5(JSAMPROW outptr, Dgp_UInt8 *r_val, Dgp_UInt8 *g_val, Dgp_UInt8 *b_val){

      outptr += RGB_PIXELSIZE;
      *outptr++ = r_val[1];
	  *outptr++ = g_val[1];
	  *outptr++ = b_val[1];
      outptr +=  RGB_PIXELSIZE;
	  *outptr++ = r_val[3];
	  *outptr++ = g_val[3];
	  *outptr = b_val[3];

}
INLINE 
void pixel_assign_1_6(JSAMPROW outptr, Dgp_UInt8 *r_val, Dgp_UInt8 *g_val, Dgp_UInt8 *b_val){

      outptr += RGB_PIXELSIZE;
      *outptr++ = *(++r_val);
	  *outptr++ = *(++g_val);
	  *outptr++ = *(++b_val);
      *outptr++ = *(++r_val);
	  *outptr++ = *(++g_val);
	  *outptr++ = *(++b_val);
}
INLINE 
void pixel_assign_1_7(JSAMPROW outptr, Dgp_UInt8 *r_val, Dgp_UInt8 *g_val, Dgp_UInt8 *b_val){
      outptr += RGB_PIXELSIZE;
      *outptr++ = *(++r_val);
	  *outptr++ = *(++g_val);
	  *outptr++ = *(++b_val);
      *outptr++ = *(++r_val);
	  *outptr++ = *(++g_val);
	  *outptr++ = *(++b_val);
      *outptr++ = *(++r_val);
	  *outptr++ = *(++g_val);
	  *outptr++ = *(++b_val);
}
INLINE 
void pixel_assign_1_8(JSAMPROW outptr, Dgp_UInt8 *r_val, Dgp_UInt8 *g_val, Dgp_UInt8 *b_val){

	  *outptr++ = *r_val;
	  *outptr++ = *g_val;
	  *outptr++ = *b_val;
}
INLINE 
void pixel_assign_1_9(JSAMPROW outptr, Dgp_UInt8 *r_val, Dgp_UInt8 *g_val, Dgp_UInt8 *b_val){
	  *outptr++ = *r_val;
	  *outptr++ = *g_val;
	  *outptr++ = *b_val;
      outptr += 2* RGB_PIXELSIZE;
	  *outptr++ = r_val[3];
	  *outptr++ = g_val[3];
	  *outptr = b_val[3];
}
INLINE 
void pixel_assign_1_10(JSAMPROW outptr, Dgp_UInt8 *r_val, Dgp_UInt8 *g_val, Dgp_UInt8 *b_val){

	  *outptr++ = *r_val;
	  *outptr++ = *g_val;
	  *outptr++ = *b_val;
      outptr += RGB_PIXELSIZE;
	  *outptr++ = r_val[2];
	  *outptr++ = g_val[2];
	  *outptr = b_val[2];
}
INLINE 
void pixel_assign_1_11(JSAMPROW outptr, Dgp_UInt8 *r_val, Dgp_UInt8 *g_val, Dgp_UInt8 *b_val){
	  *outptr++ = *r_val;
	  *outptr++ = *g_val;
	  *outptr++ = *b_val;
      outptr +=  RGB_PIXELSIZE;
	  *outptr++ = r_val[2];
	  *outptr++ = g_val[2];
	  *outptr++ = b_val[2];     
      *outptr++ = r_val[3];
	  *outptr++ = g_val[3];
	  *outptr = b_val[3];
}
INLINE 
void pixel_assign_1_12(JSAMPROW outptr, Dgp_UInt8 *r_val, Dgp_UInt8 *g_val, Dgp_UInt8 *b_val){
  
      *outptr++ = *r_val++;
	  *outptr++ = *g_val++;
	  *outptr++ = *b_val++;

      *outptr++ = *r_val;
	  *outptr++ = *g_val;
	  *outptr++ = *b_val;
}
INLINE 
void pixel_assign_1_13(JSAMPROW outptr, Dgp_UInt8 *r_val, Dgp_UInt8 *g_val, Dgp_UInt8 *b_val){
	  
      *outptr++ = *r_val++;
	  *outptr++ = *g_val++;
	  *outptr++ = *b_val++;

      *outptr++ = *r_val;
	  *outptr++ = *g_val;
	  *outptr++ = *b_val;

      outptr +=  RGB_PIXELSIZE;
      
      *outptr++ = r_val[2];
	  *outptr++ = g_val[2];
	  *outptr = b_val[2];
}
INLINE 
void pixel_assign_1_14(JSAMPROW outptr, Dgp_UInt8 *r_val, Dgp_UInt8 *g_val, Dgp_UInt8 *b_val){
        
      *outptr++ = *r_val++;
	  *outptr++ = *g_val++;
	  *outptr++ = *b_val++;
	  
      *outptr++ = *r_val++;
	  *outptr++ = *g_val++;
	  *outptr++ = *b_val++;
	  
      *outptr++ = *r_val;
	  *outptr++ = *g_val;
	  *outptr++ = *b_val;
}
INLINE 
void pixel_assign_1_15(JSAMPROW outptr, Dgp_UInt8 *r_val, Dgp_UInt8 *g_val, Dgp_UInt8 *b_val){
      *outptr++ = *r_val++;
	  *outptr++ = *g_val++;
	  *outptr++ = *b_val++;
	  
      *outptr++ = *r_val++;
	  *outptr++ = *g_val++;
	  *outptr++ = *b_val++;
	  
      *outptr++ = *r_val++;
	  *outptr++ = *g_val++;
	  *outptr++ = *b_val++;

      *outptr++ = *r_val;
	  *outptr++ = *g_val;
	  *outptr++ = *b_val;

}


void (*pixel_assign1[16])(JSAMPROW outptr, Dgp_UInt8 *r_val, Dgp_UInt8 *g_val, Dgp_UInt8 *b_val) =
{
    pixel_assign_1_0,  
    pixel_assign_1_1,  pixel_assign_1_2 ,  pixel_assign_1_3,
    pixel_assign_1_4,  pixel_assign_1_5 ,  pixel_assign_1_6,
    pixel_assign_1_7,  pixel_assign_1_8 ,  pixel_assign_1_9,
    pixel_assign_1_10,  pixel_assign_1_11 ,  pixel_assign_1_12,
    pixel_assign_1_13,  pixel_assign_1_14 ,  pixel_assign_1_15
};
