/*
 * Trade secret of Xerox Corporation.
 * Copyright (c) 1991-2001, Xerox Corporation.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */

#ifndef TFXRJPEG_H_INCLUDED
#define TFXRJPEG_H_INCLUDED

#ifndef NOIPCORE
IP_RCSINFO(tfxrjpeg_hRCSInfo, "$RCSfile: tfxrjpeg.h,v $; $Revision: 1.1 $");
/* $Date: 2003/01/03 01:41:11 $ */
#endif

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef _MSC_VER
#pragma pack(push, tfxrjpeg_h, 1)
#endif

/* tfxrjpeg.h
 *
 */

/*
 * INCLUDES
 */


/*
 * CONSTANTS
 */

/*
 * MACROS
 */

/*
 * TYPEDEFS
 */

/*
 * ENUMS
 */

/*
 * GLOBAL VARIABLE DECLARATIONS
 */

/*
 * FUNCTION PROTOTYPES
 */
ErrCode CDECL
wp_TfxDecompressStripJPEG(TFX_IMG *tfxImg, UInt8 *pCmpData,
	UInt32 dwCmpBytes, PIXR *pPixr, UInt32 dwStripHeight,
	UInt32 dwRowOffset, UInt32 *pBytesFilled);
ErrCode CDECL
wp_TfxDecompressStripJPEG_IJL(TFX_IMG *tfxImg, UInt8 *pCmpData,
	UInt32 dwCmpBytes, PIXR *pPixr, UInt32 dwStripHeight,
	UInt32 dwRowOffset, UInt32 *pBytesFilled);
ErrCode CDECL
wp_TfxGetJPEGInfo(IPWState *pIPWState, IO_COLORTYPE xColorType,
		  UInt8 *pCmpData, UInt32 dwCmpBytes,
		  UInt32 *pdwWidth, UInt32 *pdwHeight);


#ifdef _MSC_VER
#pragma pack(pop, tfxrjpeg_h)
#endif

#ifdef __cplusplus
}
#endif

#endif /* TFXRJPEG_H_INCLUDED */
