/*
 * Trade secret of Xerox Corporation.
 * Copyright (c) 1991-2001, Xerox Corporation.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */

#ifndef TFXWJPEG_H_INCLUDED
#define TFXWJPEG_H_INCLUDED

#ifndef NOIPCORE
IP_RCSINFO(tfxwjpeg_hRCSInfo, "$RCSfile: tfxwjpeg.h,v $; $Revision: 1.1 $");
/* $Date: 2003/01/03 01:41:14 $ */
#endif

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef _MSC_VER
#pragma pack(push, tfxwjpeg_h, 1)
#endif

/* tfxwjpeg.h
 *
 */

/*
 * INCLUDES
 */


/*
 * CONSTANTS
 */

/*
 * MACROS
 */

/*
 * TYPEDEFS
 */

/*
 * ENUMS
 */

/*
 * GLOBAL VARIABLE DECLARATIONS
 */

/*
 * FUNCTION PROTOTYPES
 */
#ifndef NOIPCORE
ErrCode CDECL
wp_TfxCompressStripJPEG(TFX_IMG *tfxImg, PIXR *pPixr, UInt32 dwRowOffset,
	UInt32 dwStripHeight, IO_COLORSPACE xColorSpace, UInt8 **ppCmpData,
	UInt32 *pdwCmpBytes, UInt32 *pBytesFilled);

ErrCode CDECL
wp_TfxCompressStripJPEG_IJL(TFX_IMG *tfxImg, PIXR *pPixr, UInt32 dwRowOffset,
	UInt32 dwStripHeight, IO_COLORSPACE xColorSpace, UInt8 **ppCmpData,
	UInt32 *pdwCmpBytes, UInt32 *pBytesFilled);
#endif	/* NOIPCORE */

ErrCode CDECL
wp_TfxStripJPEGTables(TFX_IMG *tfxImg, UInt8 **ppCmpData, UInt32 *pdwCmpBytes);

#ifdef _MSC_VER
#pragma pack(pop, tfxwjpeg_h)
#endif

#ifdef __cplusplus
}
#endif

#endif /* TFXWJPEG_H_INCLUDED */
