/*
 * Trade secret of Xerox Corporation.
 * Copyright (c) 1991-2001, Xerox Corporation.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */

#ifndef TFXWPUB_H_INCLUDED
#define TFXWPUB_H_INCLUDED

#ifndef NOIPCORE
IP_RCSINFO(tfxwpub_hrcsinfo, "$RCSfile: tfxwpub.h,v $; $Revision: 1.1 $");
/* $Date: 2003/01/03 01:41:14 $ */
#endif

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef _MSC_VER
#pragma pack(push, tfxwpub_h, 1)
#endif

/*
 * INCLUDES
 */

/*
 * CONSTANTS
 */

/*
 * MACROS
 */

/*
 * TYPEDEFS
 */

/*
 * ENUMS
 */

/*
 * GLOBAL VARIABLE DECLARATIONS
 */

/*
 * FUNCTION PROTOTYPES
 */
ErrCode CDECL
wp_TfxCopyTokenDictionary(TFX_IMG *srcImg, UInt8 *imgData, 
			  UInt32 dataBytes, TFX_DOC *dstDoc,
			  UInt32 **ppDictIDList);
ErrCode CDECL
wp_TfxCopyImage(TFX_IMG *srcImg, TFX_IMG *srcParentImg, TFX_PAGE *dstPage,
		TFX_IMGINFO *pOutImgInfo, Bool firstStripOnly,
		Bool useFGstripSize);
ErrCode CDECL
wp_TfxCopyPage(TFX_DOC *xSrcDoc, Int32 dwSrcPageOffset,
	       TFX_DOC *xDstDoc, Int32 dwDstPageOffset, Bool copyAnnotations);


#ifdef _MSC_VER
#pragma pack(pop, tfxwpub_h)
#endif

#ifdef __cplusplus
}
#endif

#endif /* TFXWPUB_H_INCLUDED */
