#ifndef __PAGE_STRIP_MANIP_H__
#define __PAGE_STRIP_MANIP_H__

#include "dgp_state.h"
/* for Dgp_Bool from wjr */
#include "util.h"
#include "page_strip_t.h"
#include "santa_image_t.h"

#ifdef __cplusplus
extern "C"
{
#endif

/* File page_strip_manip.h
   wbell 6/15/98
   page strip manipulation routines.

   Updated on 10/11/99 to celebrate the millenium.
*/

/* pageStripIsImgOn()
   Determines if a specified image is on this page strip.
   pstrip - the strip
   pimg - the image.
   pon - a Dgp_Bool that is set to DGP_TRUE if the image is on the
    strip, DGP_FALSE otherwise.
*/
ErrCode
pageStripIsImgOn(pageStrip * pstrip, santaImage * pimg,
		 Dgp_Bool * pon, Dgp_State * dgp_state);

#ifdef __cplusplus
}
#endif


#endif
