/*****************************************************************
 *  Trade Secret of Xerox Corporation.                           *
 *  Copyright (c) 1991-1995, Xerox Corporation.                  *
 *  All rights reserved.                                         *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/
/* Trade secret boilerplate added 1.2.2000 / dhtesq. */

/*************************************************************************
**
**  DigiPaper Codebase
**  
**	  
**  Pedro Felzenszschwalb (sp?), 19nn - 1998?
**
**  Filename:  complexity.h.
**
**  Types & prototypes for this module.  No exports.
**
**
**	Modification history:
**		Dillon H. Tracy esq. / Feb. 2000
**		o  Implemented liberr exception handling.
**		o  Search on 'dhtesq' for some of this coder's comments and modifications.
**
**  
**************************************************************************/


#ifndef COMPLEXITY_H
#define COMPLEXITY_H

#include "image.h"
#include "ccs.h"

ErrCode
getComplexity(Dgp_State *dgp_state, DgpImage_Long compMap, ComponentInfo *components, Dgp_Int32 numccs);

Dgp_Int32
remComplex(ComponentInfo *components, Dgp_Int32 numccs, Dgp_Int32 complexthresh);

#endif
