/* $Header: /project/icons/cvsroot/digipaper/src/libsupercache/sucache_t.h,v 1.1 2000/05/18 19:46:58 wbell Exp $ */

#ifndef SUCACHE_T_H
#define SUCACHE_T_H

#include "dgp_state.h"
#include "memory_sentry_t.h"

#ifdef __cplusplus
extern "C"
{
#endif


typedef struct _suXiffCache * suXiffCache;

typedef struct _suCacheEntry * suCacheEntry;

typedef struct {
  /* Suggested memory usage.*/
  Dgp_UInt32 maxMemUsage;

  /* The sentry that we should talk to about memory. If you dont know what
   * I'm talking about then you probably don't care. */
  memorySentry *psentry;

  /* Digipaper state cookie. */
  Dgp_State* dgp_state;

} suOptions;


#ifdef __cplusplus
}
#endif

#endif /* SUCACHE_T_H */
