#include"libiow.pub"
#include "dgp_state.h"
#include "uds.h"
#include "PsgFix.h"

DGP_LIBEXPORT 
ErrCode Dgp_initUds(
Dgp_State *dgp_state,
uds *u,
FILE *file
){
 DGP_PROLOGUE("Dgp_initUds",DGP_PERRSTATE);
 DGP_ERR_GEN(u == NULL,  cErrInvalidParm);
 u->fp = (void *)file;
 u->fseek  = (fseek_func)fseek;
 u->ftell  = (ftell_func)ftell;
 u->fread  = (fread_func)fread;
 u->fwrite = (fwrite_func)fwrite;
 NORMAL_RETURN;
}

