#ifndef __SILX_linecc_H__
#define __SILX_linecc_H__

/* prototyes */
#include "shrcc.pub"
#include "shrcc.prv"
#ifdef __GNUC__
#include "ansiprot.h"
#endif

#ifdef __cplusplus
extern "C"
{
#endif
ErrCode
tcly_findBufCC (
                      IPState    *pIPState,
                      CCState    *pCCState,
                      Int8* buf,
                      Bool  lastBuf,
                      Int32 startX,
                      Int32 endX,
                      Int32 startY,
                      Int32 endY,
                      Int32 accuHeight,         /* accumulated height of this buffer */
                      Int32 sectionHeight,      /*height of the first section (jbig2 compliant to have 2 sections) */
                      Int32 bpl,
                      Int32	minWidth,
                      Int32	minHeight,
                      const Int32	connectType,
                      void       *pRectData,
                      Int32 (CDECL *rectReturnProc) (
                                  IPState    *pIPState,
                                  void       *,
                                  Int32	x,
                                  Int32	y,
                                  Int32	w,
                                  Int32	h,
                                  Int32	m,
                                  Int32	nRuns,
                                  TCScanLineRun *pRuns),
                      Int32      *pRectReturnCode);

#ifdef __cplusplus
}
#endif
#endif
