/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libtok-lossy/class.h,v 1.5 2000/03/04 00:22:41 mkrocken Exp $
 *
 */

#ifndef	CLASS_H

#define	CLASS_H

extern ErrCode tokCBoxToClass(tokCBoxType *box, tokCClass *result,
		    tokOptions *opt);

extern ErrCode tokCMaybeMergeBox(TokState state, tokClassTable classes, 
                                 tokCClass c, tokCBoxType *box,
                                 Dgp_Bool *matched);

extern ErrCode tokCGenerateExemplar(TokState state, tokCClass c);

extern ErrCode tokCMaybeMergeClasses(TokState state, tokClassTable classes, 
                                     tokCClass a, tokCClass b, 
                                     Dgp_Bool *merged);

extern ErrCode tokCRejectMember(tokClassTable classes, tokCClass c, 
		    tokCBoxType *member, Dgp_Bool *rejected, tokOptions *opt);

extern ErrCode tokCAlignClass(tokCClass c, tokOptions *opt);

extern ErrCode tokCCheckMembers(tokClassTable classes, tokCClass c,
		    tokOptions *opt);

/* More status bits for class (see tok-class.h for the others) */

#define	TOKCLASS_FROZENHIST	(0x02)	/* Its histogram has been frozen */
#define	TOKCLASS_EXSYNTHETIC	(0x04)	/* The exemplar is synthetic */
#define	TOKCLASS_EXCLEAN	(0x08)	/* The exemplar doesn't need to be rebuilt */
#define	TOKCLASS_CHECKCLEAN	(0x10)	/* The class doesn't need to be rechecked */

#define	TOKCLASS_MERGECLEAN	(0x40)	/* Not changed in last merge */
#define	TOKCLASS_OKSOFAR	(0x80)	/* Not changed yet in current merge */

#endif
