/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libtok-lossy/pick.h,v 1.1 2000/03/04 00:30:07 mkrocken Exp $
 *
 * Copyright (c) 1990, 1991, 1992, 1993 Cornell University.  All Rights
 * Reserved.
 *
 * Copyright (c) 1991, 1992 Xerox Corporation.  All Rights Reserved.
 *
 * Use, reproduction, preparation of derivative works, and distribution
 * of this software is permitted.  Any copy of this software or of any
 * derivative work must include both the above copyright notices of
 * Cornell University and Xerox Corporation and this paragraph.  Any
 * distribution of this software or derivative works must comply with all
 * applicable United States export control laws.  This software is made
 * available AS IS, and XEROX CORPORATION DISCLAIMS ALL WARRANTIES,
 * EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE,
 * AND NOTWITHSTANDING ANY OTHER PROVISION CONTAINED HEREIN, ANY
 * LIABILITY FOR DAMAGES RESULTING FROM THE SOFTWARE OR ITS USE IS
 * EXPRESSLY DISCLAIMED, WHETHER ARISING IN CONTRACT, TORT (INCLUDING
 * NEGLIGENCE) OR STRICT LIABILITY, EVEN IF XEROX CORPORATION IS ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGES.
 */

#ifndef	PICK_H

#define	PICK_H

#include "dgp_state.h"

extern Dgp_Int32 pickNth(Dgp_Int32 *vals, Dgp_Int32 nvals, Dgp_Int32 whichval);
extern Dgp_Float32 pickNthFloat(Dgp_Float32 *vals, Dgp_Int32 nvals, Dgp_Int32 whichval);
extern void *pickNthGeneral(void **vals, Dgp_Int32 nvals, Dgp_Int32 whichval,
			    Dgp_Int32 (*compare)(void *p1, void *p2));
extern Dgp_Float64 frac_lower(Dgp_Int32 *vals, Dgp_Int32 nvals, Dgp_Int32 upper);

#endif
