/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libtok-lossy/template.h,v 1.17 2000/03/04 00:22:42 mkrocken Exp $
 *
 */

#ifndef TEMPLATE_H
#define TEMPLATE_H

#include "tokprivate.h"

extern ErrCode InsertModel(tokCClass c, tokCModelInfo *model,
			   Dgp_Int32 tx, Dgp_Int32 ty, tokOptions *opt);

extern ErrCode DeleteModel(tokCClass c, tokCModelInfo *model, Dgp_Int32 tx, Dgp_Int32 ty,
			tokOptions *opt);

extern ErrCode ModelToSum(tokCModelInfo *model, tokOptions *opt,
            tokCPixelSum **result);

extern ErrCode MakeExemplarFromPixelSum(TokState state, tokCClass class,
                                        Dgp_Bool forceMake);

extern ErrCode MergePixelSumsWithOffset(tokCClass new, tokCClass old,
					Dgp_Int32 tx, Dgp_Int32 ty, tokOptions *opt);

extern ErrCode makeRealHist(tokCClass c, tokOptions *opt);

#endif

