/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libtok-lossy/tokprivate.h,v 1.20 2000/11/08 18:24:01 mkrocken Exp $
 *
 */

/*
 * Internal declarations for the tokeniser.
 */

#ifndef	TOKPRIVATE_H

#define	TOKPRIVATE_H

#include <stdlib.h>
#include "util.h"
#include "image.h"
#include "list.h"

#include "tok-lossy.h"
#include "tokclass.h"
#include "tokclasstable.h"


typedef struct {
   /* The configuration. */
   tokOptions options;

   /* The classtable. */
   struct _tokClassTable classes;

   /* These are kept to avoid constant malloc/free of memory. */
   Dgp_Int32 *search_order;   /* Local search area within the classtable. */
   Dgp_Int32 search_count;
   Dgp_Int32 ngoal_vals;     /* See template.c */
   Dgp_Int32 *goal_vals;    
   Dgp_Int32 nsum_vals;
   Dgp_Int32 *sum_vals;
} _tokState;

#endif
