#ifndef __WINPRINT_H
#define __WINPRINT_H

#include <windows.h>
#include <stdio.h>
#include "uds.h"
#include "dgp_state.h"
#include "dgp_w32_err_control.h"
#include "dgp_err_printers.h"
#include "image_defs.h"

#ifdef __cplusplus
extern "C"
{
#endif

ErrCode
printDoc(Dgp_Int8 * docName,
         uds *docuds, 
         Dgp_Int32 name_offset, 
         HDC hDC, 
         Dgp_Int32 firstPage, 
         Dgp_Int32 lastPage, 
         Dgp_Bool report, 
         Dgp_Bool createJob,
         Dgp_State *dgp_state);

ErrCode
printRAW(Dgp_Int8 *inFile, 
         Dgp_Int8 *prtName, 
         Dgp_Int8 *portName, 
         Dgp_Bool report, 
         Dgp_State *dgp_state);

#define STATUS_PAGE 0
#define STATUS_DOC  1
#define STATUS_NONE 2

#ifdef __cplusplus
}
#endif

#endif /* __WINPRINT_H */
