/* $Header: /project/icons/cvsroot/digipaper/src/libzephyr/decodebytes.c,v 1.1 2000/04/26 04:41:45 wbell Exp $ */

#include "decodebytes.h"
#include "dgp_rcs.h"

DGP_RCSID("@(#)$Header: /project/icons/cvsroot/digipaper/src/libzephyr/decodebytes.c,v 1.1 2000/04/26 04:41:45 wbell Exp $");


void
decodeShort( Dgp_UInt16 *s, Dgp_UInt8 *c, Dgp_Bool swapBytes)
{
  Dgp_Int32 i;
  Dgp_UInt8 *r = (Dgp_UInt8 *)s;

  if( !swapBytes) {
    for( i = 0; i < (Dgp_Int32)sizeof( Dgp_UInt16); i++) {
      r[ i] = c[ i];
    }
  } 
  else {
    for( i = 0; i < (Dgp_Int32)sizeof( Dgp_UInt16); i++) {
      r[ i] = c[ sizeof( Dgp_UInt16) - (i + 1)];
    }
  }
}

void
decodeLong( Dgp_UInt32 *lg, Dgp_UInt8 *c, Dgp_Bool swapBytes)
{
  Dgp_Int32 i;
  Dgp_UInt8 *r = (Dgp_UInt8 *)lg;

  if( !swapBytes) {
    for( i = 0; i < (Dgp_Int32)sizeof( Dgp_UInt32); i++) {
      r[ i] = c[ i];
    }
  } 
  else {
    for( i = 0; i < (Dgp_Int32)sizeof( Dgp_UInt32); i++) {
      r[i] = c[ sizeof( Dgp_UInt32) - (i + 1)];
    }
  }
}
