/* $Header: /project/icons/cvsroot/digipaper/src/libzephyr/nop.h,v 1.1 2000/04/26 04:41:54 wbell Exp $ */

#ifndef NOP_H
#define NOP_H

#include "zephprivate.h"


extern ErrCode
zephNopOpen( Dgp_State *dgp_state, 
             uds *u, Dgp_UInt32 offset, 
             Dgp_UInt32 compSize, 
             Dgp_Int32 srcW, Dgp_Int32 srcH,
             DgpCoord_Resolution *srcRes,
             void **decodeState);

extern Dgp_UInt32
zephNopUsage( void *decodeState);

extern ErrCode
zephNopAbilities( void *decodeState,
                  Dgp_Int32 dstMinX, Dgp_Int32 dstMinY,
                  zephReadType *type,
                  DgpCoord_Orientation *orient,
                  DgpCoord_Resolution *dstRes,
                  Dgp_Int32 *dstX, Dgp_Int32 *dstY,
                  Dgp_Int32 *dstW, Dgp_Int32 *dstH,
                  Dgp_UInt32 *maxMemRequired,
                  Dgp_Int32 srcOriginX, Dgp_Int32 srcOriginY,
                  Dgp_UInt8 *cantDo);

extern ErrCode
zephNopRead( void *decodeState, 
             void *dst, Dgp_Int32 dstBpl,
             Dgp_Int32 dstMinX, Dgp_Int32 dstMinY,
             zephReadType type,
             DgpCoord_Orientation orient,
             DgpCoord_Resolution *dstRes,
             Dgp_Int32 dstX, Dgp_Int32 dstY,
             Dgp_Int32 dstW, Dgp_Int32 dstH,
             Dgp_UInt32 *maxMemRequired,
             Dgp_Int32 srcOriginX, Dgp_Int32 srcOriginY);

extern ErrCode 
zephNopClose( void *decodeState);


#endif /* NOP_H */
