/* $Header: /project/icons/cvsroot/digipaper/src/libzephyr/zephdocument.h,v 1.1 2000/04/26 04:42:02 wbell Exp $ */

#ifndef ZEPHDOCUMENT_H
#define ZEPHDOCUMENT_H

#include "dgp_state.h"
#include "uds.h"
#include "zephdocument_t.h"

#ifdef __cplusplus
extern "C"
{
#endif


extern ErrCode
zephOpenDocument( Dgp_State *dgp_state, uds *u, zephDocumentInfo *pDocInfo);

extern ErrCode
zephCloseDocument( zephDocumentInfo *pDocInfo);

extern Dgp_UInt32
zephGetDocumentMemoryUsage( zephDocumentInfo docInfo);

extern ErrCode
zephGetSymlibCount( zephDocumentInfo docInfo, Dgp_UInt32 *libcCount);

#ifdef __cplusplus
}
#endif


#endif /* ZEPHDOCUMENT_H */

