/* $Header: /project/icons/cvsroot/digipaper/src/libzephyr/zephdocument_t.h,v 1.3 2000/12/29 18:23:29 mkrocken Exp $ */

#ifndef ZEPHDOCUMENT_T_H
#define ZEPHDOCUMENT_T_H

#include "dgp_types.h"
#include "list.h"

#ifdef __cplusplus
extern "C"
{
#endif


typedef struct _zephPrivateDocumentInfo * zephPrivateDocumentInfo;

typedef struct _zephDocumentInfo {
  Dgp_UInt8 version, revision;
  Dgp_UInt16 pageCount;
  Dgp_UInt32 refPage;
  
  Dgp_UInt8 userFlags;
  zephPrivateDocumentInfo privateInfo;
} *zephDocumentInfo;


#ifdef __cplusplus
}
#endif


#endif /* ZEPHDOCUMENT_T_H */

