/* $Header: /project/icons/cvsroot/digipaper/src/libzephyr/zephpage_t.h,v 1.5 2000/11/17 21:46:25 dtracy Exp $ */

#ifndef ZEPHPAGE_T_H
#define ZEPHPAGE_T_H

#include "resolution_t.h"

#ifdef __cplusplus
extern "C"
{
#endif

#define ZEPH_MAINIMAGE_LAYER     1
#define ZEPH_MAINIMAGE_NUMBER    0

typedef struct _zephPrivatePageInfo * zephPrivatePageInfo;

typedef struct _zephPageInfo {
  Dgp_UInt16 pageNum;
  Dgp_UInt32 width, height;
  DgpCoord_Resolution res;
  Dgp_UInt32 layerCount;
  Dgp_UInt32 *imageCounts;
  
  Dgp_UInt8 userFlags;
  zephPrivatePageInfo privateInfo;
} *zephPageInfo;


#ifdef __cplusplus
}
#endif


#endif /* ZEPHPAGE_T_H */
