@echo off
setlocal

if "%JPEG_REGRESSION_DIR%"=="" echo You must set the JPEG_REGRESSION_DIR var to run this test

erase /F /Q %JPEG_REGRESSION_DIR%\compdiff.nt.out

REM Script to test the compression function
REM Invoked as : runcomptest
REM ----------------------------------------

set BaseTestDir=%JPEG_REGRESSION_DIR%\
set DiffLog = %BaseTestDir%\compdiff.nt.out
set DataFileDir=%BaseTestDir%\compressiontest

REM First delete the difflog if it exists..

echo "*************Starting to run compression tests for JPEG 6b********"
echo

for %%i in (%DataFileDir%\*.data) do call comprun.cmd %%~ni

echo
echo "*************End of Compression Tests******************"

:quit
endlocal
