
#include "stdafx.h"
#include "PDFCompress.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void CPDFCompress::getMAC (unsigned char* mac)
{ 
   char   psBuffer[128];
   FILE   *chkdsk;

       /* Run DIR so that it writes its output to a pipe. Open this
    * pipe with read text attribute so that we can read it 
         * like a text file. 
    */
   if( (chkdsk = _popen( "ipconfig /all", "rt" )) == NULL )
      exit( 1 );

   /* Read pipe until end of file. End of file indicates that 
    * CHKDSK closed its standard out (probably meaning it 
         * terminated).
    */
   while( !feof( chkdsk ) )
   {
      if( fgets( psBuffer, 128, chkdsk ) != NULL )
	{
	  if (strstr(psBuffer, "Physical Address"))
	    {
	      char* token;
	      char* mark = strstr (psBuffer, ":");

	      if (mark)
		{
		  int i;

		  /*printf( psBuffer );*/
		  mark += 2;
		  token = strtok (mark, "-");
		  for (i = 0; i < 6 && token; i++)
		    {
		      int number, temp;

		      /* convert the Hex number to an int */
		      temp = (int) token[0];
		      if (temp < 58) temp -= 48;
		      else temp -= 55;

		      number = (int) token[1];
		      if (number < 58) number -= 48;
		      else number -= 55;

		      number += temp * 16;
		      mac[i] = (unsigned char) number;

		      token = strtok (NULL, "-");
		    }
		  break;
		}  
	    }     
	}
   }

   /* Close pipe and print return value of CHKDSK. 
      printf( "\nProcess returned %d\n", _pclose( chkdsk ) ); */
   _pclose( chkdsk );
}
