
#ifndef JB2ENCODE
#define JB2ENCODE

namespace ipcore
{
#include "jtokapi.h"
}

class Jb2Encode
{
public:

    Jb2Encode (bool arithmetic);
    ~Jb2Encode ();

    bool addPage (ipcore::PIXR* page);
    bool endSectionGetDict (char** data, int* data_size);
    bool getNextPosBlock (char** data, int* data_size);

    void freeData (void* data) {m_tokopt.dgp_state->a.free (data); }

    int getImgCount () { return m_imCount; }
    bool inAddState () { return m_addState; }

private:

    bool endSection ();
    bool startSection ();

    /* counter and state */
    int m_imCount;
    bool m_addState;

    /* dgp Handle */
    ipcore::DgpApi_Handle m_handle;

    /* dgp_structs */
    ipcore::DgpApi_Options m_opts;
    ipcore::tokOptions m_tokopt;
    ipcore::LlTokOptions m_llTokOpt;

};

#endif
