/* */
/* NOTE: REMOVING FROM THIS HASHTABLE DOES NOT WORK. */
/* I'll fix it if I get around to it. For now, noone does  */
/* removes anyway. Actually, I don't think anyone even uses */
/* this code except my halftone stuff. We have no */
/* idea who originally wrote this buggy hash-table. */
/* */
/* */
/* 1.8.2000 / dhtesq. */
/* I'm changing all the shorts in here to longs, particularly for the result */
/* of the hash operation, so I can hash with 32-bit pointers... */

/* $Header: /project/icons/cvsroot/digipaper/src/libadt/hash_table.h,v 1.13 2003/02/10 22:53:18 mkrocken Exp $ */

/* hash_table.h
   
   This module implements a hash table using the SMImage. */

#ifndef HASH_TABLE_H
#define HASH_TABLE_H

#include "sm_image.h"
#include "util.h"
#include "dgp_state.h"

#ifdef __cplusplus
extern "C"
{
#endif

typedef DgpAdt_sm_elt_type DgpAdt_ht_elt; /* sm_elt_type is set in sm_image.h 
			       (currently, it's (void *)) */

typedef Dgp_Bool (*DgpAdt_htComparator)(void *, DgpAdt_ht_elt, DgpAdt_ht_elt);
typedef Dgp_UInt16 (*DgpAdt_htHash)(void *, DgpAdt_ht_elt);
typedef void (*DgpAdt_htLastCall)(void *);

typedef struct {
  DgpAdt_SMImage sm;
  DgpAdt_htComparator isequal;
  DgpAdt_htHash hash;
  DgpAdt_htLastCall last_call;
  void *hash_cookie;
  void *cookie;
  Dgp_Int32 next_y_to_get;
  Dgp_Int32 next_x_to_get;
  Dgp_UInt16 expected_size;
  Dgp_State *dgp_state;
} *DgpAdt_HashTable;

DGP_LIBEXPORT ErrCode 
DgpAdt_htNew(DgpAdt_HashTable *ht, void *user_cookie, DgpAdt_htComparator isequal, DgpAdt_htHash hash,
		       DgpAdt_htLastCall last_call, Dgp_UInt16 expected_size, Dgp_State *dgp_state);

DGP_LIBEXPORT void      
DgpAdt_htFree(DgpAdt_HashTable ht);

DGP_LIBEXPORT ErrCode
DgpAdt_htIsInTable(DgpAdt_HashTable ht, DgpAdt_ht_elt data, DgpAdt_ht_elt *in_table);

DGP_LIBEXPORT ErrCode   
DgpAdt_htAddToTable(DgpAdt_HashTable ht, DgpAdt_ht_elt data, DgpAdt_ht_elt *in_table);

DGP_LIBEXPORT ErrCode   
DgpAdt_htRemoveFromTable(DgpAdt_HashTable ht, DgpAdt_ht_elt data, 
				      DgpAdt_ht_elt *in_table);

DGP_LIBEXPORT void      
DgpAdt_htResetGetNextElement(DgpAdt_HashTable ht);

DGP_LIBEXPORT ErrCode   
DgpAdt_htGetNextElement(DgpAdt_HashTable ht, DgpAdt_ht_elt *in_table);

#define DGPADT_HTGET_USERCOOKIE(_ht) ((_ht)->cookie)

#ifdef __cplusplus
}
#endif

#endif
