static char rcsid[] = "@(#)$Header: /project/icons/cvsroot/digipaper/src/libadt/test-sm.c,v 1.3 2000/03/04 00:22:17 mkrocken Exp $";

#include "sm_image.h"
#include <malloc.h>
#include <stdlib.h>
#include <stdio.h>

void main() {
  
  int x,y;
  SMImage sm;
  void *e;

  smSetAllocators(malloc, free, calloc, realloc);
  sm = smNew(TRUE);
  
  for (y = 15; y < 30; y++) {
    for (x = 100; x < 105; x++) {
      fprintf(stdout,"(%d,%d)\n",x,y);
      e = (void *)malloc(sizeof(int));
      *(int *)e = y * 16 + x;
      smSet(sm,x,y,e);
    }
    for (x = 25; x < 30; x++) {
      fprintf(stdout,"(%d,%d)\n",x,y);
      e = (void *)malloc(sizeof(int));
      *(int *)e = y * 16 + x;
      smSet(sm,x,y,e);
    }
  }

  for (y = 100; y < 110; y++) 
    for (x = 100; x < 105; x++) {
      fprintf(stdout,"(%d,%d)\n",x,y);
      e = (void *)malloc(sizeof(int));
      *(int *)e = y * 16 + x;
      smSet(sm,x,y,e);
    }

  fprintf(stdout,"-------------------------------------------------\n");

  for (y = 15; y < 16; y++) 
    for (x = 0; x < 140; x++) {
      if (smIsAllocated(sm,x,y)) {
	smGet(sm,x,y,&e);
	if (e != NULL) 
	  fprintf(stdout,"sm(%2d,%2d) = %2d.\n",x,y,*(int *)e);
	else 
	  fprintf(stdout,"sm(%2d,%2d) is allocated.\n",x,y);
      }
      else 
	fprintf(stdout,"sm(%2d,%2d) is not allocated.\n",x,y);
    }

  fprintf(stdout,"-------------------------------------------------\n");

  for (y = 15; y < 30; y++) 
    for (x = 100; x < 105; x++) {
      smGet(sm,x,y,&e);
      fprintf(stdout,"sm(%2d,%2d) = %2d.\n",x,y,*(int *)e);
    }

  fprintf(stdout,"-------------------------------------------------\n");

  sm_foreach(sm,x,y) {
    fprintf(stdout,"(%2d,%2d)\n",x,y);
  }
  fprintf(stdout,"maxy = %4d\n",smGetYMax(sm));
  smFree(sm);
}
  
  
