/*////////////////////////////////////////////////////////////////////////// */
/* */
/*  DigiPaper Codebase */
/* */
/*  Ranjani Ramamurthy, Nov 4, 1998 */
/* */
/*  Filename:encode_utils.c */
/* */
/* */
/* */
/* */
/*///////////////////////////////////////////////////////////////////////// */
#ifndef LYNX
#include <wchar.h>
#endif
#include "ascii_exts.h"
#include <stdio.h>
#include <stdlib.h>

DGP_RCSID("@(#)$Header: /project/icons/cvsroot/digipaper/src/libascii/encode_utils.c,v 1.13 2003/02/10 22:53:19 mkrocken Exp $");

Dgp_Int32
get_bit(Dgp_Int8 val, Dgp_Int32 i)
{
  return (Dgp_Int32) (( (val) >> i) & 1);
}


void
print_bits(Dgp_Int8 *val)
{
  Dgp_Int32 i;

  for(i = (NUM_BITS) -1; i >= 0; i--){
    fprintf(stderr, "%d ", (int)get_bit(*val,i));
  }
  fprintf(stderr,"\n"); fflush(stderr);
}


void
assign_bit(Dgp_Int8 *bits, Dgp_Int32 pos, Dgp_Int32 value)
{
  if(value){
    /* set the bit */
    *bits = (*bits) | (Dgp_Int8)(1ul << pos);
  } else {
    /* reset the bit */
    *bits = (*bits) & (Dgp_Int8)(~( 1ul << pos));
  }
}



Dgp_Int8
get_byte(Dgp_Int32 value, Dgp_Int32 bytenum)
{
  Dgp_Int8 *val;

  val = (Dgp_Int8*)&value;

  assert( (bytenum >= 0) && (bytenum <= 3));

  return val[bytenum];
}



/*/////////////////////////////////////////////////////////////// */
