/* $Id: icrpub.h,v 1.5 2003/02/10 22:53:19 mkrocken Exp $ */ 
#ifndef ICRPUB_H 
#define ICRPUB_H 

#include "dgp_types.h"
 
#ifdef _WIN32

#ifdef OCR
#include "icr_char.h" 
typedef CHVAL FCHAR; 
#endif

#define DGP_XDOC_MAX_WORDS 1000 
#define DGP_XDOC_EOF_REACHED 1 
#define DGP_XDOC_EOF_NOT_REACHED -1 

#endif 

typedef struct{ 
  Dgp_Int32 upper_left_x; 
  Dgp_Int32 upper_left_y; 
  Dgp_Int32 lower_right_x; 
  Dgp_Int32 lower_right_y; 
} WordCoOrd; 
 
typedef struct{ 
  Dgp_Int32 start_of_word; /*Indicates if a character is the beg of a word  */
  wchar_t word_toks[5]; /*THis will hold at most one character- but we need  */
                     /*more than one char ..to be on the safe side.  */
} WordInfo; 
 
/* We will have an array of XdocData generated. Each XDOCData will contain  */
/* details about a word of text.  */
 
typedef struct{ 
  WordInfo   word_info; 
  WordCoOrd  co_ords; 
} XDOCData; 
 
#endif 
