#ifndef BLIT_TABLES
#define BLIT_TABLES

#ifdef __cplusplus
extern "C"
{
#endif

#include "dgp_types.h"

/* Here's a table for colorBlitBinaryRGB and blitBinaryRGB; it takes an 8-bit value, and gives */
/* you 6 words, which is 8 rgb values of on or off of pixels. */
extern const Dgp_UInt32 monoToRGB8bit[256][6];

/* 25.8.2000 / dhtesq. */
/* Added this one for blitting into grayscales or cmyk separations.  This time it takes an */
/* 8-bit value and gives you 2 words, which is 8 1-byte values of on or off of pixels. */
extern const Dgp_UInt32 monoToGray8bit[256][2];

/* Everybody has one. A table of how many bits in a byte. */
/* number of bits set in a particular character. It's initialized by default */
extern const Dgp_Int8 blat_bitcounts[256];

#ifdef __cplusplus
}
#endif

#endif
