/* $Header: /project/icons/cvsroot/digipaper/src/libcoord/orientation_t.h,v 1.6 2003/02/10 22:53:24 mkrocken Exp $ */

#ifndef ORIENTATION_T_H
#define ORIENTATION_T_H

#include "dgp_types.h"

#ifdef __cplusplus
extern "C"
{
#endif


typedef Dgp_UInt8  DgpCoord_Orientation;

/* change this first one and you'll break everything. santa needs ORIENT_RD */
/* to be zero so that when tokens are passed up from xiff/zephyr, their */
/* userflags (which are set to 0) mark them in the right orientation. */
#define ORIENT_RD       0
#define ORIENT_UR       (1 << 1)

#define ORIENT_RU       (1 << 2)
#define ORIENT_LU       (1 << 3)

#define ORIENT_DL       (1 << 4)
#define ORIENT_DR       (1 << 5)
#define ORIENT_UL       (1 << 6)
#define ORIENT_LD       (1 << 7)

#ifdef __cplusplus
}
#endif

#endif /* ORIENTATION_T_H */
