/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libencode/huff.h,v 1.2 2000/05/16 22:28:13 jahlborn Exp $
 *
 */

#ifndef	HUFF_H

#define	HUFF_H

#include "util.h"
#include "dgp_state.h"

/* Maximum code length */
#define	DGP_MAX_CODELEN	32

typedef struct {
    Dgp_Int32 value;
    Dgp_UInt32 code;
    Dgp_Int32 codelen;
    } DgpEncode_Huff;

DGP_LIBEXPORT ErrCode 
DgpEncode_huffmanCode(Dgp_State *dgp_state, DgpEncode_Huff *vals, Dgp_Int32 nvals);

DGP_LIBEXPORT ErrCode 
DgpEncode_huffBuildDecodeTables(Dgp_State *dgp_state, DgpEncode_Huff *vals, Dgp_Int32 nvals,
					Dgp_UInt32 *firstcode, Dgp_Int32 **index);

#endif
