/*
   @(#)$Header: /project/icons/cvsroot/digipaper/src/liberr/dgp_sm_alloc.h,v 1.1 2000/05/16 21:13:20 jahlborn Exp $ 
*/

#ifndef __DGP_SM_ALLOC_H
#define __DGP_SM_ALLOC_H

#include "dgp_state.h"

#ifdef __cplusplus
extern "C"
{
#endif


ErrCode
dgp_mallocSmall(void *cookie, 
                Dgp_Int32 pool_id, 
                void **retptr);

void
dgp_freeSmall(void *cookie, 
              Dgp_Int32 pool_id, 
              void *ptr);

ErrCode
dgp_initSmallMem(Dgp_State *dgp_state, 
                 void **cookie);

void
dgp_cleanupSmallMem(void **cookie);


void
dgp_selectPools(void *small_cookie, 
                Dgp_UInt32 selected_pools);


#ifdef __cplusplus
}
#endif

#endif /* __DGP_SM_ALLOC_H */
