/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libimage/pbmstuff.h,v 1.1 2000/03/04 00:20:53 mkrocken Exp $
 *
 */

#ifndef	PBMSTUFF_H

#define	PBMSTUFF_H

#include "util.h"
#include "dgp_state.h"
#include <stdio.h>

/* File tags */
/* Standard pbmplus tags */
#define	TAG_BINARY_COOKED	"P1"
#define	TAG_GRAY_COOKED		"P2"
#define	TAG_RGB_COOKED		"P3"
#define	TAG_BINARY		"P4"
#define	TAG_GRAY		"P5"
#define	TAG_RGB			"P6"
/* Nonstandard wjr tags */
#define	TAG_FLOAT	"Q1"
#define	TAG_DOUBLE	"Q2"
#define	TAG_LONG	"Q3"
#define	TAG_SHORT	"Q4"
#define	TAG_RGBFLOAT	"Q5"

/* Maximum line length in a non-raw P?M file */
#define	PBM_MAX_LINELEN	70

/* How big a comment buffer we'll have for reading files */
#define	LOAD_COMMENT_MAX	8192

/* Some reading routines */
DGP_LIBEXPORT Dgp_Int32 
DgpImage_pbmGetToken(FILE *f, Dgp_Bool *failed,
			  Dgp_Int8 *incomment, Dgp_Int32 *incommentsize, Dgp_State *dgp_state);
DGP_LIBEXPORT Dgp_Int32 
DgpImage_pbmGetPBMToken(FILE *f, Dgp_Bool *failed,
			     Dgp_Int8 *incomment, Dgp_Int32 *incommentsize, Dgp_State *dgp_state);

#endif
