/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libimage/rawimage.h,v 1.1 2000/03/04 00:20:53 mkrocken Exp $
 *
 */

#ifndef	RAWIMAGE_H

#define	RAWIMAGE_H

#include "image.h"
#include <stdio.h>

DGP_LIBEXPORT ErrCode
DgpImage_loadRaw(DgpImage_Type type, Dgp_Int32 width, Dgp_Int32 height, Dgp_Int8 *filename, void **image, Dgp_State *dgp_state);
DGP_LIBEXPORT ErrCode
DgpImage_loadRawF(DgpImage_Type type, Dgp_Int32 width, Dgp_Int32 height, FILE *inFile, void **image, Dgp_State *dgp_state);

#define DGPIMAGE_SAVERAW(i, n, e, s)	DgpImage_saveRaw_((void *)(i), ((i)->header.tag), (n), (e), (s))
#define DGPIMAGE_SAVERAWF(i, f, e, s)	DgpImage_saveRawF_((void *)(i), ((i)->header.tag), (f), (e), (s))

DGP_LIBEXPORT ErrCode 
DgpImage_saveRaw_(void *im, DgpImage_Type tag, Dgp_Int8 *filename,
			   DgpImage_Type endian, Dgp_State *dgp_state);
DGP_LIBEXPORT ErrCode
DgpImage_saveRawF_(void *im, DgpImage_Type tag, FILE *outFile,
			    DgpImage_Type endian, Dgp_State *dgp_state);

#endif
