#ifndef MRC2PDF_H
#define MRC2PDF_H

ErrCode  
write_mrc_forground(  PdfCookie     *pdfCookie,
                   Dgp_State     *dgp_state,
                   uds           *u,
                   Dgp_UInt8     *data,
                   Dgp_UInt32    dataSize,
                   Dgp_UInt32    fgWidth,
                   Dgp_UInt32    fgHeight,
                   Dgp_UInt8     depth,
                   Dgp_UInt32    fgObjId,
                   Dgp_UInt32    selObjId);
ErrCode  
write_mrc_selector(  PdfCookie     *pdfCookie,
                   Dgp_State     *dgp_state,
                   uds           *u,
                   Dgp_UInt8     *data,
                   Dgp_UInt32    dataSize,
                   Dgp_UInt32    selWidth,
                   Dgp_UInt32    selHeight,
                   Dgp_UInt8     depth,
                   Dgp_UInt32    selObjId);
ErrCode  
write_mrc_background(  PdfCookie *pdfCookie,
                   Dgp_State     *dgp_state,
                   uds           *u,
                   Dgp_UInt8     *data,
                   Dgp_UInt32    dataSize,
                   Dgp_UInt32    bgWidth,
                   Dgp_UInt32    bgHeight,
                   Dgp_UInt8     depth,
                   Dgp_UInt32    bgObjId);
ErrCode
write_mrc_info(    PdfCookie   *pdfCookie,
                   Dgp_State     *dgp_state,
                   uds           *u,
                   Dgp_UInt32    width,
                   Dgp_UInt32    height,
                   Dgp_UInt32    pageDPI,
                   Dgp_UInt32    *selObjId,
                   Dgp_UInt32    *fgObjId,
                   Dgp_UInt32    *bgObjId);
ErrCode
write_mrc_jbgglobal(PdfCookie     *pdfCookie,
                   Dgp_State     *dgp_state,
                   uds           *u,
                   Dgp_UInt8     *dict,
                   Dgp_UInt32    dictSize);

#endif
