/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/decextseg.h,v 1.5 2002/05/30 02:42:46 jlin Exp $
 *
 */

#ifndef	DECEXTSEG_H

#define	DECEXTSEG_H

#include "util.h"
#include "jb2file.h"
#include "segment.h"
#include "datasource.h"
#ifdef __cplusplus

extern "C"
{
#endif

extern ErrCode jb2DecodeExtension(jb2File file, DataSource data,
				  jb2Segment *segment, jb2Segment **refsegs);
extern void jb2FreeExtensionSegment(jb2Segment *segment, Dgp_State *dgp_state);

/* Some of the types and associated structures */
#define	EXT_ASCIICOMMENT	0x20000000
typedef struct {
    Dgp_Int32 npairs;
    Dgp_Int8 **names;
    Dgp_Int8 **values;
    } jb2Extension_ASCIIComment;

#ifdef __cplusplus
}
#endif


#endif

