/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/decpageinfo.h,v 1.6 2002/05/30 02:42:46 jlin Exp $
 *
 */

#ifndef	DECPAGEINFO_H

#define	DECPAGEINFO_H

#include "util.h"
#include "datasink.h"
#include "segment.h"
#include "jb2file.h"

#ifdef __cplusplus
extern "C"
{
#endif

extern ErrCode jb2DecodePageInfo(jb2File file, DataSource data,
				 jb2Segment *segment, jb2Segment **refsegs);
extern void jb2FreePageInfoSegment(jb2Segment *segment, Dgp_State *dgp_state);

extern ErrCode jb2DecodeEOPage(jb2File file, DataSource data,
			       jb2Segment *segment, jb2Segment **refsegs);
extern void jb2FreeEOPageSegment(jb2Segment *segment, Dgp_State *dgp_state);

extern ErrCode jb2DecodeEOStripe(jb2File file, DataSource data,
				 jb2Segment *segment, jb2Segment **refsegs);
extern void jb2FreeEOStripeSegment(jb2Segment *segment, Dgp_State *dgp_state);

extern ErrCode jb2DecodeEOFile(jb2File file, DataSource data,
			       jb2Segment *segment, jb2Segment **refsegs);
extern void jb2FreeEOFileSegment(jb2Segment *segment, Dgp_State *dgp_state);

#ifdef __cplusplus
}
#endif

#endif
