/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/decsymdict.h,v 1.8 2002/05/30 02:42:46 jlin Exp $
 *
 */

#ifndef	DECSYMDICT_H

#define	DECSYMDICT_H

#include "util.h"
#include "datasource.h"
#include "segment.h"
#include "jb2file.h"

#ifdef __cplusplus
extern "C"
{
#endif

extern ErrCode jb2DecodeSymDict(jb2File file, DataSource data,
				jb2Segment *segment, jb2Segment **refsegs);
extern void jb2FreeSymDictSegment(jb2Segment *segment, Dgp_State *dgp_state);

/* Utility routine for clipping out of collective bitmap */
extern void jb2ReadoutBits(Dgp_UInt32 *src, Dgp_Int32 bitoffset,
			   Dgp_Int32 srcwidth, Dgp_Int32 height,
			   Dgp_UInt32 *dest, Dgp_Int32 destwidth);

#ifdef __cplusplus
}
#endif

#endif
