/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/decsymreg.h,v 1.9 2002/05/30 02:42:46 jlin Exp $
 *
 */

#ifndef	DECSYMREG_H

#define	DECSYMREG_H

#include "util.h"
#include "datasource.h"
#include "segment.h"
#include "jb2file.h"
#include "symbol.h"
#include "decint.h"
#include "symdec.h"
#include "mqcoder.h"
#include "jbitfile.h"
#include "params.h"

#ifdef __cplusplus
extern "C"
{
#endif

extern ErrCode jb2DecodeSymReg(jb2File file, DataSource data,
			       jb2Segment *segment, jb2Segment **refsegs);
extern void jb2FreeSymRegSegment(jb2Segment *segment, Dgp_State *dgp_state);
extern ErrCode jb2RenderSymReg(jb2File file, jb2Segment *segment);
extern ErrCode jb2RenderSymRegIntoPage(jb2File file, jb2Segment *segment,
				       DgpImage_Packed page);

/* Inner routines */
extern ErrCode jb2DecodeInstances(jb2File file, jbitfile bf,
				  Dgp_Bool sbhuff, Dgp_Bool sbrefine,
				  Dgp_Bool transposed, Dgp_UInt8 refcorner,
				  Dgp_Int32 logsbstrips,
				  Dgp_Int32 sbdsoffset,
				  symDecoder symid, diDecoder fs, diDecoder ds,
				  diDecoder dt, diDecoder t, diDecoder ri,
				  diDecoder rdw, diDecoder rdh,
				  diDecoder rdx, diDecoder rdy,
				  diDecoder rsize, DataSource data,
				  DgpEncode_MQDecoder *mqdec,
				  arith_ref_params *refparams,
				  Dgp_UInt8 *refcontexts,
				  Dgp_Int32 sbnuminstances,
				  jb2SymbolInstance *instances);
extern void jb2DrawInstances(Dgp_UInt32 *bits, Dgp_Int32 w, Dgp_Int32 h,
			     Dgp_Int32 Dgp_Int32sperline, jb2SymbolInstance *instances,
			     Dgp_Int32 ninstances, Dgp_Int32 combop, Dgp_State *dgp_state);
extern void jb2FreeInstances(jb2SymbolInstance *instances, Dgp_Int32 ninstances,
			     Dgp_State *dgp_state);

/* Reference corners */
#define	JB2_BOTTOMLEFT	0
#define	JB2_TOPLEFT	1
#define	JB2_BOTTOMRIGHT	2
#define	JB2_TOPRIGHT	3

#ifdef __cplusplus
}
#endif

#endif
