/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/encint.h,v 1.9 2002/05/30 02:42:46 jlin Exp $
 *
 */

#ifndef	ENCINT_H

#define	ENCINT_H

#include "hufftable.h"
#include "jbitfile.h"
#include "mqcoder.h"

#ifdef __cplusplus
extern "C"
{
#endif

/*
 * An integer encoder
 */
typedef struct _eiEncoder *eiEncoder;
#define	NULLEIENCODER	((eiEncoder)NULL)

extern ErrCode eiNewEncoder(hufftable_spec *spec, jbitfile file, 
			      Dgp_State *dgp_state, eiEncoder *newe);
#ifndef	NOMQ
extern ErrCode eiNewEncoderMQ(DgpEncode_MQEncoder *mqenc, Dgp_UInt8 *contexts,
			      Dgp_State *dgp_state, eiEncoder *newe);
#endif
extern ErrCode eiNewEncoderEither(Dgp_Bool huff,
				    hufftable_spec *spec, jbitfile file,
				    DgpEncode_MQEncoder *mqenc, Dgp_UInt8 *contexts,
				    Dgp_State *dgp_state, eiEncoder *newe);
extern ErrCode eiEncode(eiEncoder enc, Dgp_Int32 val, Dgp_Bool oob);
extern void eiCount(eiEncoder enc, Dgp_Int32 val, Dgp_Bool oob, Dgp_Int32 *counts);
extern void eiFreeEncoder(eiEncoder enc);

/* How many bytes of contexts you need for eiNewEncoderMQ */
#define	EICONTEXTSIZE	512

#ifdef __cplusplus
}
#endif

#endif
