/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/fileerr.h,v 1.7 2002/05/30 02:42:46 jlin Exp $
 *
 */

#ifndef	FILEERR_H

#define	FILEERR_H

#include "dgp_err_control.h"

#ifdef __cplusplus
extern "C"
{
#endif

/* macro to wrap arbitrary error */
#define FILEERR(err_code, error)     DGP_ERR_CLEANUPF0(err_code, error)

/* Macros to wrap common errors */
#define BADEOF       DGP_ERR_CLEANUP(cErrIO_BadFileLength)
#define NOMEM        DGP_ERR_CLEANUP(cErrNomem)
#define	BADWRITE     DGP_ERR_CLEANUP(cErrIO_WriteError)
#define	BADREAD      DGP_ERR_CLEANUP(cErrIO_ReadError)

#ifdef __cplusplus
}
#endif

#endif
