/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/jb2mmcompressprivate.h,v 1.4 2002/05/30 02:42:46 jlin Exp $
 *
 */

#ifndef	JB2MMCOMPRESSPRIVATE_H

#define	JB2MMCOMPRESSPRIVATE_H

#include "symbol.h"

#ifdef __cplusplus
extern "C"
{
#endif

/*
 * The internal structure of a JBIG2/DigiPaper state
 * It has:
 *	ntok - number of symbols the state currently holds
 *	capacity - number of symbols the state can hold
 *	toks - a pointer into another part of the block, to a set of
 *	       jb2Symbol structures
 *	segnum - the next segment number to be assigned
 *	pagenum - the next page number to be assigned
 *
 * The jb2Symbol structures have been hacked: the bits pointer is NULL
 * or invalid, and Dgp_Int32sperline contains the "toknum" value.
 */
typedef struct {
    Dgp_Int32 ntok, capacity;
    jb2Symbol *toks;
    Dgp_Int32 segnum, pagenum;
    } dictstate;

#ifdef __cplusplus
}
#endif

#endif
