/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/segment_util.h,v 1.11 2002/05/30 02:42:47 jlin Exp $
 *
 */

#ifndef	SEGMENT_UTIL_H

#define	SEGMENT_UTIL_H

#include "util.h"
#include "segment.h"
#include "hufftable.h"
#include "jb2file.h"
#include "list.h"

extern ErrCode findUserTables(hufftable_spec ***usertables, Dgp_Int32 nusertables,
			      jb2Segment **refsegs, Dgp_Int32 nrefsegs, 
			      Dgp_State *dgp_state);
extern ErrCode jb2DecodeRegSegment(jb2File file, DataSource data,
				   jb2RegSegment *reginfo);
extern ErrCode jb2AddReferencedSegments(jb2File file, jb2Segment *segment,
					jb2Segment **newrefsegs,
					Dgp_Int32 nnewrefsegs);
extern ErrCode jb2EncodeRegSegment(jb2File file, DataSink data,
				   jb2RegSegment *reginfo);
extern ErrCode jb2MarshalSegments(jb2File file, jb2Segment *segment,
				       DgpAdt_List allsegs,
				       jb2Segment ***refsegs);
#ifdef __cplusplus
}
#endif

#endif
