/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/symdec.h,v 1.7 2002/05/30 02:42:47 jlin Exp $
 *
 */

#ifndef	SYMDEC_H

#define	SYMDEC_H

#include "jbitfile.h"
#include "symbol.h"
#include "mqcoder.h"
#include "hufftable.h"

typedef struct _symDecoder *symDecoder;

extern ErrCode symDecoderHuffman(void **symptrs, Dgp_Int32 nsyms,
				 jbitfile bf, Dgp_Int32 *lengths, 
				 Dgp_State *dgp_state, symDecoder *newdec);
#ifndef	NOMQ
extern ErrCode symDecoderArith(void **symptrs, Dgp_Int32 nsyms, DgpEncode_MQDecoder *dec, 
			       Dgp_State *dgp_state, symDecoder *newdec);
#endif

extern ErrCode symDecode(symDecoder dec, jb2Symbol **symnum);
extern void symDecoderFree(symDecoder dec);
extern Dgp_Int32 ceillog2(Dgp_Int32 n);

#ifdef __cplusplus
}
#endif

#endif
