/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/symenc.h,v 1.6 2002/05/30 02:42:47 jlin Exp $
 *
 */

#ifndef	SYMENC_H

#define	SYMENC_H

#include "jbitfile.h"
#include "symbol.h"
#include "mqcoder.h"
#include "hufftable.h"

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct _symEncoder *symEncoder;

extern ErrCode symEncoderHuffman(int nsyms, jbitfile bf, Dgp_Int32 *lengths,
				 Dgp_State *dgp_state, symEncoder *newenc);
#ifndef	NOMQ
extern ErrCode symEncoderArith(int nsyms, DgpEncode_MQEncoder *enc,
			       Dgp_State *dgp_state, symEncoder *newenc);
#endif
extern ErrCode symEncode(symEncoder enc, Dgp_Int32 symnum);
extern void symEncoderFree(symEncoder enc);

#ifdef __cplusplus
}
#endif

#endif
