/*
 * Trade secret of Xerox Corporation.
 * Copyright (c) 1991-2001, Xerox Corporation.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */

#ifndef TFXRTIFF_H_INCLUDED
#define TFXRTIFF_H_INCLUDED

#ifndef NOIPCORE
IP_RCSINFO(tfxrtiff_hRCSInfo, "$RCSfile: tfxrtiff.h,v $; $Revision: 1.1 $");
/* $Date: 2003/01/03 01:41:14 $ */
#endif

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef _MSC_VER
#pragma pack(push, tfxrtiff_h, 1)
#endif

/* tfxrtiff.h
 *
 */

/*
 * INCLUDES
 */


/*
 * CONSTANTS
 */

/*
 * MACROS
 */

/*
 * TYPEDEFS
 */

/*
 * ENUMS
 */

/*
 * GLOBAL VARIABLE DECLARATIONS
 */
extern char TfxFieldTypeSize[];


/*
 * FUNCTION PROTOTYPES
 */
ErrCode CDECL
wp_TifFXConvcopy(void *dst, const void *src, UInt16 type,
	 UInt32 count, UInt8 swap);
ErrCode CDECL
wp_TifFXIsTiff(TFX_FILE *pTfxFile, UInt32 *dwFirstIFD);
ErrCode CDECL
wp_TifFXFieldCleanup(TFX_IMG *tfxImg, TFX_TIFFIELDS *fieldList);
ErrCode CDECL
wp_TifFXGetNextIFD(TFX_IMG *tfxImg);
ErrCode CDECL
wp_TifFXReadIFD(TFX_IMG *tfxImg);
ErrCode CDECL
wp_TifFXReadGPIFD(TFX_IMG *tfxImg);
ErrCode CDECL
wp_TifFXReadFields(TFX_IMG *tfxImg, UInt32 ifdOffset, UInt32 *pNextIFD);

#ifdef _MSC_VER
#pragma pack(pop, tfxrtiff_h)
#endif

#ifdef __cplusplus
}
#endif

#endif /* TFXRTIFF_H_INCLUDED */
