/*
 * Trade secret of Xerox Corporation.
 * Copyright (c) 1991-2001, Xerox Corporation.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */

#ifndef TFXWTFX_H_INCLUDED
#define TFXWTFX_H_INCLUDED

#ifndef NOIPCORE
IP_RCSINFO(tfxwtfx_h_RCSInfo, "$RCSfile: tfxwtfx.h,v $; $Revision: 1.2 $");
/* $Date: 2003/02/10 22:53:33 $ */
#endif

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef _MSC_VER
#pragma pack(push, tfxwtfx_h, 1)
#endif

/* tfxwtfx.h
 *
 */

/*
 * INCLUDES
 */


/*
 * CONSTANTS
 */

/*
 * MACROS
 */

/*
 * TYPEDEFS
 */

/*
 * ENUMS
 */

/*
 * GLOBAL VARIABLE DECLARATIONS
 */

/*
 * FUNCTION PROTOTYPES
 */
ErrCode CDECL
wp_TfxAddAnnotation(TFX_PAGE *tfxPage, UInt16 type, UInt32 xOffset,
		 UInt32 yOffset, UInt32 width, UInt32 height,
		 UInt32 flags, UInt8 *pData, UInt32 bytes, UInt16 *pID);
ErrCode CDECL
wp_TfxWriteAnnotTableEntry(TFX_PAGE *tfxPage, Int32 fileOffset,
			TFX_ANNOTTABLEENTRY *annotTableEntry);
ErrCode CDECL
wp_TfxWriteAnnotTableHeader(TFX_PAGE *tfxPage);
ErrCode CDECL
wp_TfxDeleteAnnotation(TFX_PAGE *tfxPage, UInt16 offset,
	      UInt16 *pdwAnnotationCount);
ErrCode CDECL
wp_TfxWriteHeader(TFX_DOC *tfxDoc, UInt8 *version, UInt8 *revision);
ErrCode CDECL
wp_TfxWriteExtension(TFX_DOC *tfxDoc, TFX_DOCFIELD *docField);
ErrCode CDECL
wp_TfxWriteFieldData(TFX_DOC *tfxDoc, TFX_DOCINFO *pTfxDocInfo);
ErrCode CDECL
wp_TfxSetPageIFD(TFX_DOC *tfxDoc, UInt32 pageOffset, UInt8 flags,
	      UInt32 ifdOffset, TFX_PAGE *tfxPage);
ErrCode CDECL
wp_TfxSetAuthor(TFX_DOC *tfxDoc, Int8 *pAuthorBlock, UInt16 wAuthorBytes);
ErrCode CDECL
wp_TfxSetReferencePage(TFX_DOC *tfxDoc, Int32 dwReferencePageOffset);
ErrCode CDECL
wp_TfxGeneratePageFlags(TFX_PAGE *tfxPage, UInt8 *flags);
/*ErrCode CDECL */
/*wp_TfxWritePageTableHeader(TFX_DOC *tfxDoc); */
/*ErrCode CDECL */
/*wp_TfxWritePageTableEntry(TFX_DOC *tfxDoc, Int32 fileOffset, */
/*		       TFX_PAGETABLEENTRY *pageTableEntry); */
/*ErrCode CDECL */
/*wp_TfxRewritePageTableEntries(TFX_DOC *tfxDoc, TFX_PAGE *tfxPage); */
ErrCode CDECL
wp_TfxSetResourceOffset(TFX_DOC *tfxDoc, UInt32 bytes, UInt32 offset,
    UInt16 compression, UInt16 lastPage, UInt32 decMem,	UInt32 *pdwResourceOffset);
/*ErrCode CDECL */
/*wp_TfxWriteResourceTableHeader(TFX_DOC *tfxDoc); */
ErrCode CDECL
wp_TfxWriteResourceTableEntry(TFX_DOC *tfxDoc, Int32 fileOffset,
			 TFX_RESOURCETABLEENTRY *resourceTableEntry);
#if 0
ErrCode CDECL
wp_TfxQueueIFD(TFX_IMG *tfxImg);
#endif
ErrCode CDECL
wp_TfxWriteMockIFD(TFX_IMG *tfxImg, UInt32 fieldCount, UInt32 *fileOffset);

#ifdef _MSC_VER
#pragma pack(pop, tfxwtfx_h)
#endif

#ifdef __cplusplus
}
#endif

#endif /* TFXWTFX_H_INCLUDED*/
