#ifndef SANTA_MACROS_H
#define SANTA_MACROS_H

/* all of the destructor functions keep track of the first error, */
/* and this macro makes it a little nicer, by checking to see if the */
/* variable is already set to an error, and if not, setting it to the last */
/* error. */
#define UPDATE_ERR(errvar) \
do { \
  if((errvar) == cSuccessful) { errvar = DGP_CUR_ERROR; } \
}while(0)

#define CLEAR_STRUCT(s) \
 memset(&(s), sizeof(s), 0)

#endif
