/*****************************************************************
 *  Trade Secret of Xerox Corporation.                           *
 *  Copyright (c) 1991-1995, Xerox Corporation.                  *
 *  All rights reserved.                                         *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/
/* Trade secret boilerplate added 25.1.2000 / dhtesq. */

/*************************************************************************
**
**  DigiPaper Codebase
**  
**	  
**  Pedro Felzenszschwalb (sp?), 19nn - 1998?
**
**  Filename: propagate.h
**
**  Types & prototypes for image propagation.  No exports.
**
**
**	Modification history:
**		Dillon H. Tracy esq. / Feb. 2000
**		o  Implemented liberr exception handling;  very few changes.
**		o  Search on 'dhtesq' for some of this coder's comments and modifications.
**
**  
**************************************************************************/

#ifndef PROPAGATE_H
#define PROPAGATE_H

#include "image.h"

void
propagate_g(DgpImage_Gray image, DgpImage_Long dist);

void
propagate_rgb(DgpImage_ColorRGB image, DgpImage_Long dist);

void
propagate_l(DgpImage_Long image, DgpImage_Long dist);

ErrCode
propagate_seed_l(Dgp_State *dgp_state, DgpImage_Long image, DgpImage_Binary seeds);


#endif
