/*************************************************************************
**
**  DigiPaper Codebase
**    
**  James Ahlborn, February 1 1998
**
**  Filename: colorCC-priv.h
**
**  Description of what's implemented in this file:
**    various definitions for color connected component finding
**  
**************************************************************************/

/*
 * $Header: /project/icons/cvsroot/digipaper/src/libsupercc/colorCC-priv.h,v 1.7 2001/06/08 20:42:39 mkrocken Exp $
 */


#ifndef __COLORCC_PRIV_H
#define __COLORCC_PRIV_H

#include "colorCC.h"
#include "colorCCutil.h"
#include "colorCCstate.h"

#define DGPCC_MIN_UPDATE_COUNT 80

/* functions from colorCC.c */
ErrCode
dgpcc_updateStatus(colorCC_state *cookie);

/* functions from colorCCread.c */
ErrCode 
dgpcc_readLine(colorCC_state *cookie);

/* functions from colorCCwash.c */
ErrCode 
dgpcc_washMerge(colorCC_state *cookie);


#endif /* __COLORCC_PRIV_H */
