#ifndef	SMOOTH_TOK_H

#define	SMOOTH_TOK_H

#include "image.h"
#include "list.h"


typedef struct{

    DgpImage_Double image;
    Dgp_Int32 width;        /*minWidth of all member */
    Dgp_Int32 height;       /*minHeight of all member */
    Dgp_Int32 index;        /* number of instances for this class */
    void * userdata;
} GrayToken;


ErrCode
smoothToken( Dgp_State *dgp_state, DgpAdt_List tokList);
ErrCode
sumGrayInstances(Dgp_State *dgp_state, DgpImage_Gray cim, DgpAdt_List tokList, DgpAdt_List ccList, Dgp_Int32 pageNum);

#endif
