#ifndef HAUSCHEX_H
#define HAUSCHEX_H

#include "tokprivate.h"
#include "util.h"

extern Dgp_Bool
 EdgeHausdorffMatch(tokCModelInfo *model1, tokCImageInfo *image1,
                    tokCModelInfo *model2, tokCImageInfo *image2,
                    Dgp_Int32 *tx, Dgp_Int32 *ty,
                    tokOptions *p);

extern void 
ShiftEdgeHausdorffMatch(tokCModelInfo *model1, tokCImageInfo *image1,
                        tokCModelInfo *model2, tokCImageInfo *image2,
                        Dgp_Int32 *tx, Dgp_Int32 *ty,
                        tokOptions *p);

extern Dgp_Int32 
MinEdgePixForMismatch(tokOptions *p);

#endif

