/*****************************************************************
 *  Trade Secret of Xerox Corporation.                           *
 *  Copyright (c) 1991-1995, Xerox Corporation.                  *
 *  All rights reserved.                                         *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/

/*************************************************************************
**
**  DigiPaper Codebase
**  
**	  
**  Author:  ?;  199n-9n
**
**  Filename:  token_t.h.
**
**  Defines the token structure.
**
**
**	Modification history:
**      o  None.
**  
**************************************************************************/

/* $Header: /project/icons/cvsroot/digipaper/src/libtokcomp/token_t.h,v 1.2 2000/03/04 00:22:43 mkrocken Exp $ */

#ifndef TOKEN_T_H
#define TOKEN_T_H

#ifdef __cplusplus
extern "C"
{
#endif


typedef struct {
  Dgp_UInt32 *bits;
  void *extdata;
  Dgp_UInt32 uses;
  Dgp_UInt16 width, height;
  Dgp_UInt16 longsperline;
  Dgp_Bool committed;
  Dgp_UInt8 userflags;
} token;

#ifdef __cplusplus
}
#endif

#endif /* TOKEN_T_H */
