/*****************************************************************
 *  Trade Secret of Xerox Corporation.                           *
 *  Copyright (c) 1991-1995, Xerox Corporation.                  *
 *  All rights reserved.                                         *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/

/*************************************************************************
**
**  DigiPaper Codebase
**  
**	  
**  Author:  ?;  199n-9n
**
**  Filename:  tokpos_t.h.
**
**  Defines the tokpos structure.
**
**
**	Modification history:
**      o  None.
**  
**************************************************************************/

/* $Header: /project/icons/cvsroot/digipaper/src/libtokcomp/tokpos_t.h,v 1.2 2000/03/04 00:22:43 mkrocken Exp $ */

#ifndef TOKPOS_T_H
#define TOKPOS_T_H

#include "token_t.h"

#ifdef __cplusplus
extern "C"
{
#endif


typedef struct {
  token *tok;
  void *extdata;
  Dgp_Int16 xpos, ypos;
} tokpos;

#ifdef __cplusplus
}
#endif

#endif /* TOKPOS_T_H */
