/* $Header: /project/icons/cvsroot/digipaper/src/libzephyr/zephconst.h,v 1.1 2000/04/26 04:41:59 wbell Exp $ */

#ifndef ZEPHCONST_H
#define ZEPHCONST_H

#ifdef __cplusplus
extern "C"
{
#endif

typedef Dgp_UInt8 zephReadType;

#define ZEPHRT_COMPRESSED                   (zephReadType)(1 << 1)
#define ZEPHRT_MONO_PACKED                  (zephReadType)(1 << 2)
#define ZEPHRT_MONO_8BIT_UNPACKED           (zephReadType)(1 << 3)
#define ZEPHRT_RGB_INTERLEAVED              (zephReadType)(1 << 4)
#define ZEPHRT_CYMK_1BIT_SEPARATIONS        (zephReadType)(1 << 5)
#define ZEPHRT_CMYK_8BIT_SEPARATIONS        (zephReadType)(1 << 6)


#define ZEPH_CANT_DO_TYPE                   (1 << 1)
#define ZEPH_CANT_DO_ORIENT                 (1 << 2)
#define ZEPH_CANT_DO_RESOLUTION             (1 << 3)
#define ZEPH_CANT_DO_RECT                   (1 << 4)
#define ZEPH_CANT_DO_MEMORY                 (1 << 5)


#ifdef __cplusplus
}
#endif

#endif /* ZEPHCONST_H */
