/* $Header: /project/icons/cvsroot/digipaper/src/libzephyr/zephpage.h,v 1.2 2000/11/17 21:46:25 dtracy Exp $ */

#ifndef ZEPHPAGE_H
#define ZEPHPAGE_H

#include "zephdocument_t.h"
#include "zephpage_t.h"
#include "dgp_err_control.h"

#ifdef __cplusplus
extern "C"
{
#endif



extern ErrCode
zephOpenPage( zephDocumentInfo docInfo, Dgp_UInt16 pageNum, 
                       zephPageInfo *pPageInfo);

extern ErrCode
zephClosePage( zephPageInfo *pPageInfo);

extern Dgp_UInt32
zephGetPageMemoryUsage( zephPageInfo pageInfo);


#ifdef __cplusplus
}
#endif


#endif /* ZEPHPAGE_H */

