#ifndef COLORS_H
#define COLORS_H

#include <stdlib.h>
#include <mmcompress.h>
#include <dgp_allocators.h>
#include <color-extension.h>

#ifdef __cplusplus
extern "C"
{
#endif

#define COLOR_EXT_VERSION 0

/* Robbed from the former colordict.h... */
#define COLOR_DICTBLOCK_VERSION 1
#define COLOR_DICTBLOCK_BITS_PER_SAMPLE 8
#define COLOR_DICTBLOCK_HEADER_SIZE 26
/*//// */

typedef struct {
	Dgp_UInt16 num_dict_ids;
	Dgp_UInt32 *dict_ids;
} colorDictInfo;

typedef struct {
	colorDictInfo *color_dictinfo;
	Dgp_Int32 ext_length;
  Dgp_Int8 *data;
} colorPosExtension;


#ifdef __cplusplus
}
#endif

#endif
