@echo off

setlocal

if "%JPEG_REGRESSION_DIR%"=="" echo You must set JPEG_REGRESSION_DIR environment variable to the JPEG_REGRESSION_DIR directory & goto quit

REM This script runs a standalone test suite on the JPEG6b library
REM Invoked as: runsuites suite_name
REM ----------------------------------------------------------------------

set DIFFLOG=%JPEG_REGRESSION_DIR%\diff.nt.out
set SuiteName=0
set SuiteDir=%JPEG_REGRESSION_DIR%\
set OutputDir=%SuiteDir%
set ImageDir=%SuiteDir%\images\base
if NOT "%1"=="" set SuiteName=%1& shift


if %SuiteName%==0 echo Invoked as: runsuites suite_name & goto quit

echo "=============== Jpegtester Regression Test Suites ==============="

if EXIST %SuiteDir%\%SuiteName% goto runsuite

echo "Suite %SuiteDir%\%SuiteName% does not exist."

goto quit

REM ----------------------------------------------------------------------

:runsuite

 echo "Running %SuiteDir%\%SuiteName% suite"


 REM Clean up old output files
 REM ----------------------------------------------------------------------

 REM erase /F /Q %DIFFLOG%

 echo "=======Suitedir is %SuiteDir%================="
 REM echo 
 echo "=======Suitename is %SuiteName%==============="
 REM echo 

 REM old for %%i in (%SuiteDir%\%SuiteName%\*.data) do call driverrun.cmd %SuiteName% %%~ni 

 for %%i in (%ImageDir%\*.jpg) do call driverrun.cmd %SuiteName% %%~ni

 REM I dont know a simple way to examine the diffs
 REM ----------------------------------------------------------------------

 echo RGB TEST SUITE RESULTS
 echo ----------------------
 type %DIFFLOG%
 REM dir /OS %OutputDir%\%SuiteName%.*.diff


 REM ----------------------------------------------------------------------

 echo "===========Jpegtester Regression Test Suite Complete =========="
 echo "---------------------------------------------------------------"

:quit
endlocal

